C SGI - Version
C
C
C Folgende Aenderungen waren notwendig, um die VAX-Version an SGI
C anzupassen (siehe Kommentarzeilen "CSGI")
C
C 1) INTEGER CLI$GET_VALUE entfaellt ersatzlos
C 
C 2) LOGICAL*4 IS entfaellt ersatzlos
C   
C 3) IS=CLI$GET_VALUE('$LINE',LINE,,) wird ersetzt durch 
C    CALL GETARG(1,LINE)
C
C 4) I=INDEX(LINE,'PATSEE ') entfaellt ersatzlos      
C
C 5) in der Zeile OPEN(UNIT=LP,FILE=NAME//'.REP',STATUS='NEW',  
C                    +CARRIAGECONTROL='LIST',ERR=5) 
C    wird CARRIAGECONTROL='LIST' ersatzlos gestrichen
C
C 6) NAME=LINE(I+7:) wird ersetzt durch NAME=LINE
C
C 7) IF(I.EQ.0)GOTO 5 wird ersatzlos gestrichen
C
C 8) Vor den OPEN-Anweisungen wird die Laenge des Dateinames
C    ueber die Funktion IBLANK=INDEX(NAME,' ') bestimmt.
C    In den OPEN-Anweisungen wird IBLANK angegeben.
C
C 9) Fehlermeldung 
C     4  FORMAT(/' ** CANNOT OPEN FILE(S)'/)   
C     5  WRITE(*,4)
C    ersetzt durch
C     4  FORMAT(/' ** CANNOT OPEN FILE: ',A40/)   
C     5  WRITE(*,4)NAME
C
C 10) Die logische Variable EX wird definiert (siehe 11 und 12)
C
C 11) Vor dem Oeffnen des .REP-Files wird ein gegebenfalls 
C     existierendes altes File geloescht.
C
C 12) a) Das LST-File ist nicht mehr UNIT-6 sondern 16, damit bei
C        WRITE(*,*) auf den Bildschirm geschrieben wird.
C     b) Nach LI=6 wird ein .LST-File geoffnet, so dass nicht mehr
C        mit ASSIGN in .COM-Files gearbeitet werden muss. 
C
C 13) Variable FILNAM eingefuehrt, damit bei Fehlermeldungen der
C     Dateiname ausgegeben werden kann.                  
C     FILNAM in alle VAX-COMMON-Bloecke eingetragen. 
C
C 14) Datum wird in IMONTH,IDAY,IYEAR
C     Uhrzeit in ISECND,IMINUT,IHOUR gespeichert.
C     Fuer das Datum wird SGI-spezifische Routine IDATE benoetigt,
C     fuer die Uhrzeit wird ITIME benutzt, das die Werte an das
C     Array IARR uebergibt.
C
C 15) Die Zeit, fuer den Programmablauf wird ueber die SGI-spezifische
C     Funktion TIME abgefragt und in den Variablen izeit1 (Start) sowie
C     izeit2 (Programmende) abgelegt.
C
C 16) Extensions muessen jetzt in Kleinbuchstaben eingeben werden.
C     Bei Dateinamen ist es egal.
C
C 17) Die systemspezifischen Routinen IDATE, ITIME, GETARG werden aus
C     getrennten fortran-DATEIEN gelesen.
C     datum.f      ! aktuelles Datum
C     readline.f   ! Liest einen String aus der Eingabezeile
C     systime.f    ! verbrauchte Zeit
C     uhrzeit.f    ! aktuelle Zeit
C
C=======================================================================
C Weitere Aenderungen von MB (siehe Kommentarzeilen "CMB"):
C
C  1) Neue COMMON-Bloecke werden in der Datei PATSEE.INC deklariert.
C     diese Datei wird mit include 'PATSEE.INC' in die Unterprogramme
C     PATSA, PATSB, PATSC, PATSD, PATSE und RESET eingelesen.
C
C  2) Unterprogramm RESET eingebaut.
C
C  3) Bei der READ-Anweisung ist jetzt auch ein Lesen des Fragments
C     von Datei moeglich.
C
C  4) Neue PATSEE-Befehle:
C     a) LIST NOAT  schreibt die Koordinaten der Atome nicht mehr ins
C                   LST-FILE
C        LIST $A    schreibt nur die Koordinaten der Atome ins
C                   LST-FILE, die mit A beginnen; vier Character duerfen
C                   vorgegeben werden; 10 $-Anweisungen sind moeglich.
C     b) FRAG FILE  liest die FRAG-Karte und die Atome von der Datei
C                   .PFR
C
C  5) Die Koordinaten der eingelesenen Atome werden nur dann auf das LST-
C     File geschrieben, wenn sie direkt aus dem INP-File gelesen wurden.
C     Daher wurde die folgende Aenderung eingebaut:
C       4                 WRITE(LI,7)IC,IR  !vorher
C       4  IF(.NOT.FRGFIL)WRITE(LI,7)IC,IR  !nachher
C
C  6) Variable ATEMP in SUBROUTINE PATSE eingebaut
C
C  7) "SGI-Version in den Programmkopf eingebaut
C
C  8) Variable NROTS zaehlt die Anzahl der getesteten Rotations-
C     orientierungen (wird nur in PATSD gebraucht)
C
C  9) Beim Einstieg in die Subroutines wird eine Meldung ausgegeben
C     PATSA  WRITE(*,*)' INTERPRET INSTRUCTIONS'
C     PATSB  WRITE(*,*)' ANALYSE AND STORE EXPERIMENTAL DATA ' 
C     PATSD  WRITE(*,501)IT    ROTATION SEARCH FOR name
C     PATSE  WRITE(*,301)IT    TRANSLATION SEARCH FOR name
C
C 10) Variable NREFND zaehlt die Anzahl der Verfeinerten Positionen pro
C     Rotationsloesung (wird nur in PATSE gebraucht)
C
C 11) NQ     ist die Anzahl durch den vorlaeufigen Packungstest verworfener 
C            Orientierungen bei der Translationssuche.
C     NRTPRS ist die Anzahl wegen zu geringem TPRSUM verworfener 
C            Orientierungen bei der Translationssuche.
C     NF     ist die Anzahl durch den endgueltigen Packungstest verworfener 
C            Orientierungen bei der Translationssuche.
C     (NQ und NF gab es schon bei EE, sie wurden aber nicht ausgegeben.)
C     
C=======================================================================
C
C                 * * *  P A T S E E  * * * 
C   
C           ERNST EGERT (UNIVERSITY OF GOETTINGEN)  
C FRAGMENT SEARCH BY INTEGRATED PATTERSON AND DIRECT METHODS
C     SGI VERSION - COMPATIBLE WITH SHELXS-86 - MAY 1987
C   
C ** NEXT STATEMENT MUST HAVE C IN COLUMN 1 IF NOT FORTRAN-77 **
      CHARACTER*1 IH,IT 
CSGI      INTEGER CLI$GET_VALUE 
CSGI      LOGICAL*4 IS  
      CHARACTER*3 AMONTH(12)
      DATA  AMONTH/'Jan','Feb','Mar','Apr','May','Jun',
     &             'Jul','Aug','Sep','Oct','Nov','Dec'/
      LOGICAL EX
      INTEGER IARR(3) 
C   
CMB
      include 'PATSEE.INC'
CSGI
      CALL RESET
      CALL DATUM(IMONTH,IDAY,IYEAR)
      CALL UHRZEIT(IARR)     
      CALL SYSTIME(IARR,IZEIT1)    
   
C   
C ** LM = DIMENSION OF A (TO BE EXTENDED FOR LARGE STRUCTURES) **   
      LM=150000  
        DO 1 K=1,LM 
   1    A(K)=0. 
C   
C ** MD = NUMBER OF 3-BIT PATTERSON VALUES STORED IN ONE REAL **
      MD=7  
C   
C ** SET UNITS FOR INPUT (LR), PRINTER (LI), 'CARDPUNCH' (LP) **
C **                 AND BINARY SCRATCH (LB)                  **
CSGI      IS=CLI$GET_VALUE('$LINE',LINE,,)  
CSGI      I=INDEX(LINE,'PATSEE ')   
      CALL READLINE(LINE)
CSGI  IF(I.EQ.0)GOTO 5  
CSGI
      NAME=LINE  
      IBLANK=INDEX(NAME,' ') 
      LR=5  
CSGI  
      FILNAM=NAME(1:IBLANK-1)//'.inp'
      OPEN(UNIT=LR,FILE=FILNAM,STATUS='OLD',ERR=5)
      
      LI=16  
CSGI
      FILNAM=NAME(1:IBLANK-1)//'.lst'
      INQUIRE(FILE=FILNAM,EXIST=EX)
      IF(EX) THEN
         OPEN(UNIT=LI,FILE=FILNAM,STATUS='OLD',ERR=5)
         CLOSE(LI,STATUS='DELETE')
      ENDIF
      OPEN(UNIT=LI,FILE=FILNAM,STATUS='NEW',ERR=5)
CSGI
      WRITE(LI,100)IARR(1),IARR(2),IARR(3),IDAY,AMONTH(IMONTH),IYEAR
100   FORMAT(' Program started at ',I2,':',I2,':',I2,' on ',
     &       I2,'-',A3,'-',I2)
     
      WRITE(LI,'(/A/)')' *** Old .lst-File deleted *** '
 
      LP=12 
CSGI
      FILNAM=NAME(1:IBLANK-1)//'.rep'
      INQUIRE(FILE=FILNAM,EXIST=EX)
      IF(EX) THEN
         OPEN(UNIT=LP,FILE=FILNAM,STATUS='OLD',ERR=5)
         CLOSE(LP,STATUS='DELETE')
         WRITE(LI,'(/A/)')' *** Old .rep-File deleted *** '
      ENDIF
      OPEN(UNIT=LP,FILE=FILNAM,STATUS='NEW',ERR=5) 

      LB=2  
CSGI
      FILNAM=NAME(1:IBLANK-1)//'.TMP'
      OPEN(UNIT=LB,FILE=FILNAM,STATUS='SCRATCH',  
     +FORM='UNFORMATTED',ERR=5) 
C   
C CALL SUBROUTINES (OVERLAYS)   
      CALL PATSA
      CALL PATSB
      IF(MZ.EQ.2)GOTO 3 
   2  CALL PATSC
      IF(ABS(A(51)).LT.0.5)GOTO 3   
      CALL PATSD
      GOTO 2
   3  CALL PATSE
      IF(A(25).GT.0.5)GOTO 2
      GOTO 6
CSGI
   4  FORMAT(/' ** CANNOT OPEN FILE: ',A40/)   
   5  WRITE(*,4)FILNAM
   6  CONTINUE

      CALL DATUM(IMONTH,IDAY,IYEAR)
      CALL UHRZEIT(IARR)
      CALL SYSTIME(IARR,IZEIT2) 
      WRITE(LI,200)IARR(1),IARR(2),IARR(3),IDAY,AMONTH(IMONTH),IYEAR
200   FORMAT(' Program stopped at ',I2,':',I2,':',I2,' on ',
     &       I2,'-',A3,'-',I2)
C     IF(IZEIT2.LT.IZEIT1)IZEIT1=IZEIT1-(365*86400) ! 86400= Anzahl s pro Tag
      WRITE(LI,300)IZEIT2-IZEIT1
300   FORMAT(/' Elapsed seconds: ',I15) 

      IREST=IZEIT2-IZEIT1
      ISECND=MOD(IREST,60)
      IMINUT=MOD(IREST-ISECND,3600)/60
      IHOUR = (IREST-ISEC-IMINUT*60)/3600

      WRITE(LI,400)IHOUR,IMINUT,ISECND
400   FORMAT(/' Elapsed time [h:m:s]: ',I4,':',I2,':',I2)
      STOP  
      END   
C   
C --------------------------------------------------------------
C   
      SUBROUTINE PACK(X,IC) 
C   
C PACK FOUR CHARACTERS INTO ONE REAL
C   
C ** NEXT STATEMENT MUST HAVE C IN COLUMN 1 IF NOT FORTRAN-77 **
      CHARACTER*1 IH,IT,IC  
C   
      COMMON /WORD/ IH(50),IT(40)   
      DIMENSION IC(4)   
      X=0.  
        DO 2 I=1,4  
        J=1 
   1    IF(IC(I).EQ.IH(J))GOTO 2
        J=J+1   
        IF(J.LT.50)GOTO 1   
   2    X=X*50.+FLOAT(J-1)  
      RETURN
      END   
C   
C --------------------------------------------------------------
C   
      SUBROUTINE UNPACK(X,IC)   
C   
C UNPACK FOUR CHARACTERS OUT OF ONE REAL
C   
C ** NEXT STATEMENT MUST HAVE C IN COLUMN 1 IF NOT FORTRAN-77 **
      CHARACTER*1 IH,IT,IC  
C   
      COMMON /WORD/ IH(50),IT(40)   
      DIMENSION IC(4)   
      Y=X+0.5   
      J=INT(Y*8.E-6)+1  
      IC(1)=IH(J)   
      J=INT(AMOD(Y*4.E-4,50.))+1
      IC(2)=IH(J)   
      J=INT(AMOD(Y*2.E-2,50.))+1
      IC(3)=IH(J)   
      J=INT(AMOD(Y,50.))+1  
      IC(4)=IH(J)   
      RETURN
      END   
C   
C --------------------------------------------------------------
C   
      SUBROUTINE HKL(W,X,Y,Z)   
C   
C UNPACK REFLECTION INDICES STORED IN ONE POSITIVE REAL 
C   
      Z=AINT(2.5E-5*W+0.5)  
      X=W-40000.*Z  
      X=AINT(X+SIGN(0.5,X+0.5)) 
      Y=AINT(5.E-3*X+SIGN(0.5,X+0.5))   
      X=X-200.*Y
      X=AINT(X+SIGN(0.5,X+0.5)) 
      RETURN
      END   
C   
C --------------------------------------------------------------
C   
      SUBROUTINE PATSA  
C   
C INTERPRET INSTRUCTIONS
C   
C ** NEXT STATEMENT MUST HAVE C IN COLUMN 1 IF NOT FORTRAN-77 **
      CHARACTER*1 IH,IT,IA,IB,IC,IG,IR  
CSGI
      CHARACTER*4 COM
C   
CMB
      include 'PATSEE.INC'
      DIMENSION C(24),IA(32),IB(32),IR(76),AN(32),IC(4),IG(50)  
C   
C ** FOLLOWING DATA STATEMENTS TO INITIALISE CHARACTER VARIABLES ** 
C ** MAY REQUIRE MODIFICATION (E.G. 'X' TO 1HX AND '''' TO 1H')  ** 
C ** FOR COMPILERS WHICH DO NOT CONFORM TO FORTRAN-77 STANDARD.  ** 
C ** N.B. THE CHARACTER " IS NOT IN THE FORTRAN-77 STANDARD SET. ** 
C   
      DATA IG/'0','1','2','3','4','5','6','7','8','9','.','-',  
     +'+','X','Y','Z',',','=','/',' ','*','''','"','(',')',':', 
     +'A','B','C','D','E','F','G','H','I','J','K','L','M','N',  
     +'O','P','Q','R','S','T','U','V','W','$'/  
C   
C ENCODED COMMANDS  
C   
      DATA C/2423469.,5712287.,3576887.,4692295.,5536938.,5578828., 
     +5849245.,5477294.,5733839.,5604239.,3983832.,4852380.,
     +5451329.,3848969.,5454538.,5704538.,3601480.,5746744.,
     +3329213.,3349244.,1952193.,6081695.,3993843.,2423469./
C   
C SYMBOLS AND ATOMIC NUMBERS OF STORED ELEMENTS 
C   
      DATA IA/'H','B','C','N','O','F','N','A','S','P','S',  
     +'C','K','C','M','F','C','N','C','A','S','B','M','R',  
     +'A','S','S','I','O','P','A','H'/  
C   
      DATA IB/' ',' ',' ',' ',' ',' ','A','L','I',' ',' ',  
     +'L',' ','R','N','E','O','I','U','S','E','R','O','U',  
     +'G','N','B',' ','S','T','U','G'/  
C   
      DATA AN/1.,5.,6.,7.,8.,9.,11.,13.,14.,15.,16.,17.,
     +19.,24.,25.,26.,27.,28.,29.,33.,34.,35.,42.,44.,  
     +47.,50.,51.,53.,76.,78.,79.,80./  
CSGI   
      WRITE(LI,1)   
      WRITE(*,1)   
      INCLUDE 'VERSION.INC'
CMB
      WRITE(*,*)' INTERPRET INSTRUCTIONS'
CMB
        DO 2 I=1,50 
   2    IH(I)=IG(I) 
C   
C DEFAULT PARAMETERS
C   
      LX=25 
      LL=1  
      LQ=0  
      LY=65 
      MI=4  
      MJ=0  
      MX=0  
      MS=0  
      MG=0  
      A(26)=1.  
      A(27)=0.3 
      A(28)=100.
      A(40)=0.5 
      A(41)=1.8 
      A(42)=2.4 
      A(43)=100.
      A(44)=100.
      A(45)=1.  
      A(47)=1.  
      A(50)=1.  
      A(52)=5.  
      A(53)=6.  
      A(54)=100.
      A(55)=0.2 
      A(56)=250.
      A(64)=1.  
      A(65)=1.  
      A(69)=1.  
      A(73)=1.  
C   
C READ INSTRUCTION  
C   
      F=0. 
CMB Anfang
C Falls das Fragment von Datei eingelesen wird, wird eine alternative
C READ-Anweisung ausgefuehrt: 
   3  CONTINUE                  
      IF (FRGFIL) THEN 
         READ(24,6,END=9999)IC,IR   
      ELSE
         READ(LR,6,END=591)IC,IR   
      ENDIF
C
C Neue Patsee-Befehle:
C
      DO 1001 I=1,4
1001     COM(I:I)=IC(I)
      DO 1002 I=1,76
1002     ZEILE(I:I)=IR(I)
C      
C LIST
      IF(COM.EQ.'LIST') THEN
         WRITE(LI,'(1X,A4,A75)')COM,ZEILE(1:76)
         IF(INDEX(ZEILE,'NOAT').GT.0) NOAT=.TRUE.
1003     IDOLAR=INDEX(ZEILE(1:76),'$')
         IF (IDOLAR.GT.0) THEN
            NLSTAT=NLSTAT+1
            I=INDEX(ZEILE(IDOLAR:76),' ')+IDOLAR-1
            ALSTAT(NLSTAT)=ZEILE(IDOLAR+1:I-1)
            LLSTAT(NLSTAT)=I-(IDOLAR+1)
            ZEILE(IDOLAR:IDOLAR)=' '
            GOTO 1003
         ENDIF
         GOTO 3
      ENDIF
C    
C FRAG 
      IF(COM.EQ.'FRAG') THEN
         IF(INDEX(ZEILE,'FILE').GT.0) THEN       
            FRGFIL=.TRUE.
            IBLANK=INDEX(NAME,' ')
            OPEN(UNIT=24,FILE=NAME(1:IBLANK-1)//'.pfr',
     &           STATUS='OLD')
            READ(24,6,END=9999)IC,IR
            NK=11
            GOTO 10 ! Dekodierung der Eingabeparameter
         ENDIF
      ENDIF
CMB Ende
      CALL PACK(A(LX),IC)   
      IF(F.LT.0.5)GOTO 4
      IF(ABS(A(LX)-C(13)).GT.0.5)GOTO 3 
      F=0.  
   4  IF(.NOT.FRGFIL)WRITE(LI,7)IC,IR  
      IF(A(20).LT.0.5)WRITE(LP,6)IC,IR  
        DO 5 NK=1,23
        IF(ABS(C(NK)-A(LX)).LT.0.5)GOTO 8   
   5    CONTINUE
      NK=1  
      GOTO 10   
   6  FORMAT(80A1)  
   7  FORMAT(1X,80A1)   
   8  IF(NK.EQ.1)GOTO 3 
      IF(NK.NE.2)GOTO 10
        DO 9 I=1,40 
   9    IT(I)=IR(I) 
      GOTO 3
C   
C DECODE INSTRUCTION
C   
  10  NA=0  
        DO 11 I=1,15
  11    G(I)=0. 
      NJ=LY+7   
      L=LY+21   
      N=0   
  12  W=1.  
  13  V=0.  
      NB=0  
      Y=1.  
      U=10. 
      Z=1.  
      GOTO 15   
  14  Z=Y*Z 
      V=U*ABS(V)+Z*X
      NB=1  
      IF(V.EQ.0.)GOTO 15
      V=SIGN(V,W)   
      W=V   
  15  N=N+1 
      IF(N.NE.7)GOTO 16 
      IF(NK.EQ.13)N=67  
  16  K=10  
      IF(N.GT.76)GOTO 19
      X=0.  
        DO 17 K=1,19
        IF(IR(N).EQ.IH(K))GOTO 18   
  17    X=X+1.  
      K=1   
      GOTO 19   
  18  IF(K.LT.11)GOTO 14
      K=K-9 
  19  IF(NK.NE.5)GOTO 27
C   
C SYMM  
C   
      GOTO(15,20,29,29,21,21,21,22,23,22),K 
  20  U=1.  
      Y=0.1 
      GOTO 15   
  21  K=K+NJ
      A(K)=W
      GOTO 12   
  22  A(L)=A(L)+AINT(24.5*V)/24.
      L=L+1 
      NJ=NJ+3   
      IF(NJ+8.LT.L)GOTO 12  
      LY=LY+12  
      IF(LQ)25,3,25 
C   
C CONTINUATION LINES AND ERRORS 
C   
  23  IF(NK.EQ.5)GOTO 25
      IF(NK.NE.6)GOTO 24
      IF(NA.LT.1)GOTO 25
  24  READ(LR,6)IC,IR   
      IF(F.LT.0.5)WRITE(LI,7)IC,IR  
      IF(A(20).LT.0.5)WRITE(LP,6)IC,IR  
      CALL PACK(C(24),IC)   
      N=0   
      IF(ABS(C(24)-C(1)).LT.0.5)GOTO 12 
  25  WRITE(LI,26)  
      STOP  
  26  FORMAT(/' ** UNSUITABLE INPUT INSTRUCTION'///)
  27  IF(K.EQ.2)GOTO 20 
      IF(NB.EQ.0)GOTO 31
      NA=NA+1   
      IF(NA.GT.15)GOTO 25   
      G(NA)=V   
  28  IF(K-9)30,23,33   
  29  A(L)=AINT(24.5*V)/24. 
  30  IF(K.NE.3)GOTO 12 
      W=-1. 
      GOTO 13   
  31  IF(K.EQ.1)K=6 
      IF(IABS(K-6).GT.1)GOTO 28 
      IF(IR(N).EQ.IH(20))GOTO 28
        DO 32 K=1,4 
        IF(N.GT.76)GOTO 33  
        IF(IR(N).EQ.IH(17))GOTO 12  
        IF(IR(N).EQ.IH(18))GOTO 24  
        IF(IR(N).EQ.IH(19))GOTO 33  
        IF(IR(N).EQ.IH(20))GOTO 12  
  32    N=N+1   
      GOTO 12   
C   
C CELL  
C   
  33  IF(NK.GT.18)GOTO 3
      IF(NK.NE.3)GOTO 36
      IF(NA.NE.7)GOTO 25
        DO 34 J=1,7 
        IF(G(J).LT.0.01)GOTO 25 
  34    A(J)=G(J)   
      U=2.*A(2)*A(3)*A(4)   
        DO 35 J=2,4 
        X=1.74533E-2*A(J+3) 
        G(J)=COS(X) 
        G(J+3)=SIN(X)   
        A(J+9)=U*G(J)/A(J)  
  35    A(J+6)=A(J)*A(J)
      X=(G(2)*G(3)-G(4))/(G(5)*G(6))
      Y=SQRT(ABS(1.-X*X))   
      A(14)=1./(A(2)*G(6)*Y)
      A(16)=1./(A(3)*G(5))  
      A(15)=X*A(16)/Y   
      A(17)=(-G(6)*G(2)*X-G(5)*G(3))/(A(4)*G(5)*G(6)*Y) 
      A(19)=1./A(4) 
      A(18)=-G(2)*A(19)/G(5)
      GOTO 3
C   
C LATT  
C   
  36  IF(NK.NE.4)GOTO 37
      IF(G(1).LT.0.)A(23)=1.
      IF(LL.NE.1)GOTO 25
      LL=INT(ABS(G(1))) 
      IF(LL.EQ.0)GOTO 25
      IF(LL-8)3,25,25   
  37  IF(NK.NE.6)GOTO 59
      IF(LX.NE.25)GOTO 25   
      IF(LL.GT.65)GOTO 54   
      N=3*LL
      L=INT(4.1-2.*A(23))   
        DO 38 I=1,15
  38    E(I)=0. 
        DO 39 I=4,12
  39    E(I)=0.5
      IF(N-12)42,40,44  
  40    DO 41 I=4,12,4  
  41    E(I)=0. 
  42  IF(N.NE.9)GOTO 45 
      E(4)=0.666667 
      E(7)=0.333333 
        DO 43 I=5,6 
        E(I)=0.333333   
  43    E(I+3)=0.666667 
      GOTO 45   
  44  E(LL-1)=0.
      N=4   
  45  LL=LY+8   
        DO 46 K=2,L,2   
          DO 46 J=1,N,3 
          LL=LL+4   
          A(LL)=3.-FLOAT(K) 
          A(LL+1)=E(J)+99.5 
          A(LL+2)=E(J+1)+99.5   
  46      A(LL+3)=E(J+2)+99.5   
      LQ=LL+3   
C   
C CHECK LATT/SYMM   
C   
      M=LY+12   
      N=LQ  
        DO 47 K=65,LY,12
          DO 47 L=M,LL,4
          N=N+3 
          A(N)=AMOD(A(L)*(0.143*A(K)+0.277*A(K+1)+  
     +    0.811*A(K+2))+A(K+9)+A(L+1)+0.5,1.)   
          A(N+1)=AMOD(A(L)*(0.143*A(K+3)+0.277*A(K+4)+  
     +    0.811*A(K+5))+A(K+10)+A(L+2)+0.5,1.)  
  47      A(N+2)=AMOD(A(L)*(0.143*A(K+6)+0.277*A(K+7)+  
     +    0.811*A(K+8))+A(K+11)+A(L+3)+0.5,1.)  
        DO 53 K=65,LY,12
          DO 52 L=M,LL,4
          I=LQ  
  48      I=I+3 
          IF(I.GT.N)GOTO 52 
          X=AMOD(A(L)*(A(I)*A(K)+A(I+1)*A(K+1)+ 
     +    A(I+2)*A(K+2))+A(K+9)+A(L+1)+0.5,1.)  
          Y=AMOD(A(L)*(A(I)*A(K+3)+A(I+1)*A(K+4)+   
     +    A(I+2)*A(K+5))+A(K+10)+A(L+2)+0.5,1.) 
          Z=AMOD(A(L)*(A(I)*A(K+6)+A(I+1)*A(K+7)+   
     +    A(I+2)*A(K+8))+A(K+11)+A(L+3)+0.5,1.) 
          NB=0  
          J=LQ  
  49      J=J+3 
          IF(J.GT.N)GOTO 50 
          IF(ABS(X-A(J))+ABS(Y-A(J+1))+ABS(Z-A(J+2)).LT.0.001)  
     +    NB=NB+1   
          GOTO 49   
  50      IF(NB.EQ.1)GOTO 48
          WRITE(LI,51)  
          STOP  
  51      FORMAT(/' ** INCONSISTENT LATT/SYMM'///)  
  52      CONTINUE  
  53    CONTINUE
      IF(A(2)*A(2)+A(3)*A(3)+A(4)*A(4).GT.0.1)GOTO 54   
      WRITE(LI,115) 
      STOP  
C   
C SFAC  
C   
  54  IF(NA.GT.0)GOTO 58
      K=0   
  55  K=K+1 
      IF(K.GT.75)GOTO 3 
      IF(IR(K).EQ.IH(19))GOTO 3 
      IF(IR(K).EQ.IH(20))GOTO 55
      IF(IR(K).EQ.IH(18))GOTO 25
        DO 56 J=1,32
        IF(IR(K).NE.IA(J))GOTO 56   
        IF(IR(K+1).EQ.IB(J))GOTO 57 
  56    CONTINUE
      GOTO 25   
  57  LQ=LQ+1   
      A(LQ)=AN(J)   
      K=K+1 
      GOTO 55   
  58  LQ=LQ+1   
      A(LQ)=AINT(G(1)+G(3)+G(5)+G(7)+G(9)+0.5)  
      IF(NA-14)25,3,25  
C   
C END (SET 'END 7' ALWAYS FOR VMS)  
C   
  59  IF(NK.NE.14)GOTO 61   
 591  F=1.  
      WRITE(LI,60)  
  60  FORMAT(/1X)  
CSGI
      IBLANK=INDEX(NAME,' ') 
      FILNAM=NAME(1:IBLANK-1)//'.pat'
      OPEN(UNIT=7,FILE=FILNAM,STATUS='OLD',ERR=602)   
      LR=7  
      IF(LR.EQ.LI)GOTO 25   
      IF(LR.EQ.LP)GOTO 25   
      IF(LR.EQ.LB)GOTO 25   
      GOTO 3
 601  FORMAT(/' ** CANNOT OPEN .pat FILE'///)   
 602  WRITE(LI,601) 
      STOP  
C   
C UNIT  
C   
  61  IF(NK.NE.7)GOTO 64
      IF(NA.NE.LQ-LL-3)GOTO 25  
      A(25)=0.  
      J=LL+4
      LX=LQ+1   
      LK=LX 
        DO 62 I=1,NA
        IF(G(I).LT.0.)GOTO 25   
        W=A(J)*G(I) 
        A(20)=A(20)+W   
        A(24)=A(24)+A(J)*W  
        A(22)=AMAX1(A(22),A(J)*A(J))
  62    J=J+1   
      A(21)=999.1/A(24) 
      A(22)=A(22)*A(21) 
      WRITE(LI,63)A(20),A(21),A(22) 
      GOTO 3
  63  FORMAT(/' F(000) =',F8.1,'    PATTERSON SCALE =', 
     +F7.4,'    HIGHEST SINGLE VECTOR =',F6.1/) 
C   
C SPIN  
C   
  64  IF(NK.NE.10)GOTO 66   
        DO 65 I=1,3 
  65    A(I+57)=G(I)
      IF(3-NA)25,3,25   
C   
C FRAG  
C   
  66  IF(NK.NE.11)GOTO 71   
      A(26)=G(1)
      IF(A(26).GT.2.1)GOTO 25   
      IF(NA.LT.2)GOTO 68
      IF(ABS(A(26)).LT.0.1)GOTO 25  
        DO 67 I=2,4 
        IF(G(I).LT.0.1)GOTO 25  
        X=1.74533E-2*G(I+3) 
        G(I+3)=COS(X)   
        IF(G(I+3).GT.0.99)GOTO 25   
  67    G(I+6)=SIN(X)   
      X=(G(5)*G(6)-G(7))/(G(8)*G(9))
      Y=SQRT(ABS(1.-X*X))   
      A(45)=1./(G(2)*G(9)*Y)
      A(47)=1./(G(3)*G(8))  
      A(46)=A(47)*X/Y   
      A(48)=(-G(9)*G(5)*X-G(8)*G(6))/(G(4)*G(8)*G(9)*Y) 
      A(50)=1./G(4) 
      A(49)=-G(5)*A(50)/G(8)
      GOTO 70   
  68    DO 69 I=46,49   
  69    A(I)=0. 
      A(45)=1.  
      A(47)=1.  
      A(50)=1.  
      GOTO 3
  70  IF(7-NA)25,3,25   
C   
C TRAN  
C   
  71  IF(NK.NE.9)GOTO 74
      IF(NA.EQ.0)G(1)=0.5   
      IF(ABS(G(1)).LT.1.E-6)GOTO 25 
      NA=MAX0(NA,1) 
        DO 72 I=1,NA
  72    A(I+38)=G(I)
      IF(ABS(A(40)).LT.1.E-6)GOTO 25
      IF(INT(ABS(A(40))+0.01).GE.1)GOTO 73  
      S=ABS(A(39))  
      IF(S.LT.1.)S=A(2)*A(3)*A(4)/8.
      A(40)=SIGN(AMIN1(AMAX1(0.01*S,10.),50.),A(40))
  73  IF(A(42).LT.0.)MG=1   
      IF(6-NA)25,3,3
C   
C ROTS  
C   
  74  IF(NK.NE.8)GOTO 77
      IF(NA.EQ.0)G(1)=0.5   
      IF(ABS(G(1)).LT.1.E-6)GOTO 25 
      IF(ABS(G(1)).LT.1.)G(1)=SIGN(FLOAT(MAX0(((720/(LY-53)+
     +INT(ABS(A(52))+0.1)+7)/5)*5000,20000)),G(1))+G(1) 
      NA=MAX0(NA,1) 
        DO 75 I=1,NA
  75    A(I+50)=G(I)
      IF(ABS(A(58))+ABS(A(59))+ABS(A(60)).LT.0.001)GOTO 76  
      IF(LX.GT.LK)GOTO 25   
  76  IF(ABS(A(52)).LT.0.99)GOTO 25 
      IF(4-NA)25,3,3
C   
C MOVE  
C   
  77  IF(NK.NE.12)GOTO 79   
      IF(NA.LT.4)G(4)=1.
        DO 78 I=1,4 
  78    A(I+60)=G(I)
      IF(4-NA)25,3,3
C   
C RFOM  
C   
  79  IF(NK.NE.15)GOTO 80   
      IF(ABS(G(1)).GT.1.E-6)A(27)=G(1)  
      IF(NA.GT.1)A(28)=G(2) 
      IF(A(28).LT.0.9999)GOTO 25
      IF(2-NA)25,3,3
C   
C TFOM  
C   
  80  IF(NK.NE.16)GOTO 82   
      IF(ABS(G(1)).GT.1.E-6)A(55)=G(1)  
      IF(NA.GT.1)A(56)=G(2) 
      IF(A(55).GT.0.)GOTO 81
      IF(A(56).LT.0.9999)GOTO 25
  81  IF(2-NA)25,3,3
C   
C CODE  
C   
  82  IF(NK.NE.17)GOTO 86   
      MX=1  
      IF(NA.NE.7)GOTO 84
      E(1)=G(1) 
        DO 83 I=2,7 
        E(I)=G(I)   
        IF(E(I).LE.E(I-1))GOTO 25   
  83    CONTINUE
      GOTO 3
  84  E(7)=G(1) 
      IF(G(2).LT.0.9)GOTO 25
        DO 85 I=1,6 
        J=7-I   
        G(1)=G(1)-G(2)  
  85    E(J)=G(1)   
      IF(2-NA)25,3,25   
C   
C ATOMS 
C   
  86  IF(NK.NE.1)GOTO 94
      IF(LX.EQ.25)GOTO 25   
      J=INT(ABS(G(1))+0.1)  
      IF(J.EQ.0)GOTO 25 
      IF(J.GT.99)GOTO 25
      M=J+LL+3  
      IF(M.GT.LQ)GOTO 25
      IF(NA.LT.5)G(5)=1.
      IF(G(5).LT.0.)GOTO 25 
      G(5)=AMOD(G(5),10.)   
      IF(G(5).LT.0.001)GOTO 25  
      IF(G(5).GT.1.001)GOTO 25  
      LX=LX+1   
      G(6)=A(M)*G(5)
      IF(G(6).LT.0.5)G(1)=-ABS(G(1))
      G(7)=A(26)
      IF(ABS(G(7)).LT.0.1)GOTO 89   
      G(2)=G(2)/A(45)   
      G(3)=(G(3)-G(2)*A(46))/A(47)  
      G(4)=(G(4)-G(2)*A(48)-G(3)*A(49))/A(50)   
      IF(INT(G(7)+0.1).NE.1)GOTO 87 
      IF(ABS(A(51)).GT.0.5)GOTO 90  
  87  J=2   
      K=3   
        DO 88 I=58,60   
        J=J+1   
        IF(J.GT.4)J=J-3 
        K=K+1   
        IF(K.GT.4)K=K-3 
        U=COS(A(I)) 
        V=SIN(A(I)) 
        W=G(J)  
        G(J)=W*U-G(K)*V 
  88    G(K)=W*V+G(K)*U 
      IF(INT(G(7)+0.1).EQ.1)GOTO 90 
      G(4)=G(2)*A(17)+G(3)*A(18)+G(4)*A(19) 
      G(3)=G(2)*A(15)+G(3)*A(16)
      G(2)=G(2)*A(14)   
      IF(G(7).GT.1.5)GOTO 90
  89  W=1.  
      GOTO 91   
  90  W=0.  
  91    DO 92 J=2,4 
  92    G(J)=A(64)*G(J)+A(J+59)*W   
      IF(G(7).LT.-0.1)G(7)=0.   
        DO 93 J=1,7 
        A(LX)=G(J)  
  93    LX=LX+1 
      IF(IABS(NA-5).LT.2)GOTO 3 
      IF(IABS(NA-9).EQ.2)GOTO 3 
      GOTO 25   
C   
C TWIS  
C   
  94  IF(NK.NE.18)GOTO 101  
      IF(A(25).GT.0.5)GOTO 25   
      IF(LX.LT.LQ+9)GOTO 25 
      IF(NA.EQ.0)GOTO 25
      IF(NA.LT.4)G(4)=2.
      IF(NA-2)95,96,97  
  95  G(3)=G(1) 
      G(2)=10.  
      GOTO 99   
  96  G(3)=G(1)+355.
      GOTO 98   
  97  IF(G(3).LT.G(1))GOTO 25   
  98  IF(G(2).LT.0.5)GOTO 25
  99  A(25)=AINT((G(3)-G(1)+0.1)/G(2))+1.1  
      G(1)=G(1)-G(2)
      E(8)=FLOAT(LX)
        DO 100 I=1,4
 100    E(I+8)=G(I) 
      IF(4-NA)25,3,3
C   
C READ  
C   
 101  IF(NK.NE.13)GOTO 25   
      IF(NA.NE.2)GOTO 25
      MQ=INT(G(1)+0.1)  
      A(1)=A(1)/(2.*SIN(8.726646E-3*G(2)))  
      LX=LX-8   
      IF(LX.LT.LK)GOTO 105  
      MZ=0  
      IF(ABS(A(51)).GT.0.5)MZ=1 
      IF(ABS(A(39)).GT.0.1)MZ=MZ+2  
      IF(MZ.NE.0)GOTO 102   
      WRITE(LI,107) 
      STOP  
 102  MY=0  
      MU=0  
      IF(A(25).GT.0.5)MZ=MZ+4   
      T=0.  
      U=0.  
        DO 103 J=LK,LX,8
        T=T+A(J+6)*A(J+6)   
        U=AMAX1(U,A(J+6))   
        IF(INT(A(J+7)+0.1).EQ.2)MU=MU+1 
        IF(INT(A(J+7)+0.1).EQ.0)MJ=MJ+1 
        IF(INT(A(J+7)+0.1).NE.1)GOTO 103
        MY=MY+1 
        IF(MZ.NE.2)GOTO 103 
        A(J+4)=A(J+2)*A(17)+A(J+3)*A(18)+A(J+4)*A(19)   
        A(J+3)=A(J+2)*A(15)+A(J+3)*A(16)
        A(J+2)=A(J+2)*A(14) 
 103    CONTINUE
      IF(MU.GT.0)MI=7   
      MK=((LX-LK)/8-MY+2)*LY
      IF(A(23).LT.0.5)MK=-MK
      IF(MY.GT.1)GOTO 110   
      IF(MY.NE.0)GOTO 104   
      WRITE(LI,108) 
      STOP  
 104  IF(IABS(MZ-4).EQ.2)GOTO 110   
      WRITE(LI,109) 
      STOP  
 105  WRITE(LI,106) 
      STOP  
 106  FORMAT(/' ** ATOMS MISSING'///)   
 107  FORMAT(/' ** NEITHER ROTS NOR TRAN FOUND'///) 
 108  FORMAT(/' ** NO FRAGMENT 1 FOUND'///) 
 109  FORMAT(/' ** CANNOT ROTATE ONE ATOM'///)  
 110  A(64)=T*FLOAT(LY-53)*FLOAT(LL-LY-8)/(A(24)*48.)   
      A(22)=U*U*A(21)   
      A(24)=0.  
      N=(LX-LK)/8+1 
      WRITE(LI,111)N,MY 
      IF(MU.GT.0)WRITE(LI,112)MU
      IF(MJ.GT.0)WRITE(LI,113)MJ
      WRITE(LI,114)A(64),A(22)  
      IF(A(64).GT.1.005)WRITE(LI,116)   
 111  FORMAT(//' SIZE OF SEARCH FRAGMENT(S):',I7,' ATOMS OF',   
     +' WHICH',I7,' BELONG TO FRAGMENT 1')  
 112  FORMAT(50X,I7,8X,'TO FRAGMENT 2') 
 113  FORMAT(50X,I7,3X,'TO FIXED FRAGMENTS')
 114  FORMAT(/' FRACTIONAL SCATTERING POWER =',F5.2,15X,
     +'HIGHEST MODEL VECTOR =',F6.1//)  
 115  FORMAT(/' ** CELL INSTRUCTION MISSING'///)
 116  FORMAT(//' ** WARNING: FRACTIONAL SCATTERING POWER',  
     +' GREATER THAN 1.00'//)   
      RETURN
C nach 9999 wird gesprungen, wenn das Ende des .pfr-Files gefunden wurde
9999  CONTINUE
      CLOSE(24)         ! Datei .pfr schliessen
      FRGFIL=.FALSE.    ! Variable so setzen, dass jetzt wieder von .inp
                        ! gelesen wird.
      GOTO 3            ! weiteren Befehl interpretieren
      END   
C   
C --------------------------------------------------------------
C   
      SUBROUTINE PATSB  
C   
C ANALYSE AND STORE EXPERIMENTAL DATA   
C   
C ** NEXT STATEMENT MUST HAVE C IN COLUMN 1 IF NOT FORTRAN-77 **
      CHARACTER*1 IH,IT,IC,ID   
C   
CMB
      include 'PATSEE.INC'
      DIMENSION IP(21),IC(4),ID(4)
CMB
      WRITE(*,*)' ANALYSE AND STORE EXPERIMENTAL DATA ' 
CMB  
C   
C READ LARGEST E-VALUES 
C   
      NE=LX+8   
      ME=NE-4   
      M=ME+4*MIN0(MQ,INT(ABS(A(43))+0.1))-1 
      I=0   
   1  N=MIN0(MQ-I,4)
      IF(N.LT.1)GOTO 4  
      READ(LR,3)(IN(K),IN(K+4),IN(K+8),G(K),IN(K+12),K=1,N) 
      I=I+N 
        DO 2 J=1,N  
        IF(ME.GT.M)GOTO 1   
        IF(G(J).LT.0.)GOTO 2
        ME=ME+4 
        A(ME)=FLOAT(IN(J))+200.*(FLOAT(IN(J+4))+
     +  200.*FLOAT(IN(J+8)))
        A(ME+1)=G(J)+100.*FLOAT(IN(J+12))   
   2    CONTINUE
      GOTO 1
   3  FORMAT(3(3I3,F6.3,I2,2X),3I3,F6.3,I2) 
   4  IF(ME.GT.NE)GOTO 8
      WRITE(LI,5)   
      STOP  
   5  FORMAT(/' ** MISSING DATA'///)
   6  FORMAT(1X,4A1,2I4,6X,4A1,2(F8.3,2I3)) 
   7  FORMAT(4A1,2I4,6X,4A1,2(F8.3,2I3))
C   
C PATT/GRID 
C   
   8  MB=ME+4   
      READ(LR,7)IC,IN(1),IN(2),ID,A(33),IN(3),IN(4),
     +A(36),IN(5),IN(6) 
      WRITE(LI,6)IC,IN(1),IN(2),ID,A(33),IN(3),IN(4),   
     +A(36),IN(5),IN(6) 
        DO 9 I=1,2  
        A(I+28)=FLOAT(IN(I))
        A(I+33)=FLOAT(IN(I+2))*0.01-0.5 
   9    A(I+36)=100./FLOAT(IN(I+4)) 
      A(33)=0.01*A(33)-0.5  
      A(36)=100./A(36)  
      ML=INT(ABS(A(29))*1.1-2.2)
      MC=2600/MD+1  
      MP=MB+MC*INT(A(30)+0.1)-1 
C   
C TRANSPOSED SYMMETRY AND LATTICE OPERATORS 
C   
      LQ=LL 
      IF(A(23).LT.0.5)LQ=(LL+LY+8)/2
      LH=MP+1+(LQ-65)*3/4   
      IF(LH+22.GT.LM)GOTO 20
      LZ=LY+12  
      LJ=MP+1   
      LS=LJ-9   
        DO 14 K=65,LY,12
        LS=LS+6 
        L=K 
        M=K+3   
        N=K+6   
        IF(ML)12,11,10  
  10    I=N 
        N=M 
        M=L 
        L=I 
        GOTO 12 
  11    I=L 
        L=M 
        M=N 
        N=I 
  12    IF(A(29).GT.0.)GOTO 13  
        I=M 
        M=N 
        N=I 
  13      DO 14 I=1,3   
          A(LS+3)=A(L)  
          A(LS+6)=A(M)  
          A(LS+9)=A(N)  
          L=L+1 
          M=M+1 
          N=N+1 
  14      LS=LS+1   
      LN=LS+9   
      LH=LN-3   
        DO 19 K=LZ,LQ,4 
        LH=LH+3 
        L=K+1   
        M=K+2   
        N=K+3   
        IF(ML)17,16,15  
  15    I=N 
        N=M 
        M=L 
        L=I 
        GOTO 17 
  16    I=L 
        L=M 
        M=N 
        N=I 
  17    IF(A(29).GT.0.)GOTO 18  
        I=M 
        M=N 
        N=I 
  18    A(LH)=A(L)  
        A(LH+1)=A(M)
  19    A(LH+2)=A(N)
C   
C ESTIMATE ARRAY SPACE  
C   
  20  M=MIN0(2*MY*(MY-1),6000)+INT(A(28)+0.1)   
      IF(ABS(A(39)).GT.0.1)GOTO 21  
      MT=M+5*MY+5*INT(ABS(A(52))+3.1)   
      IF(A(25).GT.1.)MT=MT+5*INT(ABS(A(52))+0.1)
      GOTO 24   
  21  N=(3*(ME-NE+4)*(LY-53))/16
      N=N+5*INT(ABS(A(44))+0.1)+12*INT(ABS(A(40))+1.1)+ 
     +INT(A(56)+0.1)
      IF(ABS(A(51)).GT.0.5)GOTO 22  
      MT=N  
      IF(A(25).GT.1.)MT=MT+5*MY 
      GOTO 24   
  22  MT=5*MY+5*INT(ABS(A(52))+0.1) 
      IF(A(25).GT.1.)GOTO 23
      MT=MT+MAX0(M,N)   
      GOTO 24   
  23  MT=MT+MAX0(M+5*INT(ABS(A(52))+3.1),N) 
  24  MT=MT+LH+22   
      WRITE(LI,33)LM,MT 
      IF(LM.GT.MT)GOTO 35   
      WRITE(LI,32)  
      STOP  
  25  WRITE(LI,26)L,J   
      STOP  
  26  FORMAT(/' ** BAD DATA - LAYER',I3,' - LINE',I3///)
  27  FORMAT(////' DISTRIBUTION OF ENCODED PATTERSON FUNCTION') 
  28  FORMAT(/'  - TEST LEVELS GENERATED AUTOMATICALLY -')  
  29  FORMAT(//' TEST LEVELS',5X,7F8.0//' ENCODED VALUE',I6,
     +7(2X,I6)//' FREQUENCY',4X,8I8)
  30  FORMAT(/' ** WARNING: AVERAGE VALUE OUTSIDE EXPECTED RANGE'/) 
  31  FORMAT(/' ** WARNING: DISTRIBUTION MAY NOT BE SUITABLE'/) 
  32  FORMAT(/' ** NOT ENOUGH MEMORY'///)   
  33  FORMAT(//' ARRAY SPACE AVAILABLE:',I7,'  -  REQUIRED:',I7)
  34  FORMAT(I3,I2,25I3/26I3)   
C   
C FIND TEST LEVELS  
C   
  35  NS=51*IN(2)   
      IF(MX.EQ.1)GOTO 41
        DO 36 J=1,21
  36    IP(J)=0 
        DO 37 I=1,NS
        READ(LR,34)M,N,IN   
        WRITE(LB)M,N,IN 
          DO 37 J=1,51  
          IF(IN(J).LT.-10)IN(J)=-10 
          IF(IN(J).GT.10)IN(J)=10   
          K=IN(J)+11
  37      IP(K)=IP(K)+1 
      NK=(NS*51)/2  
      N=0   
        DO 38 I=1,21
        N=N+IP(I)   
        IF(N.GT.NK)GOTO 39  
  38    CONTINUE
  39  IF(IABS(I-11).EQ.10)A(24)=1.  
      E(2)=FLOAT(I)-12. 
      S=AMAX1(AMIN1(A(22)/3.,10.),3.)   
      E(1)=E(2)-S   
        DO 40 J=3,7 
  40    E(J)=E(J-1)+S   
      GOTO 43   
  41    DO 42 I=1,NS
        READ(LR,34)M,N,IN   
        WRITE(LB)M,N,IN 
  42    CONTINUE
  43  REWIND LB 
      A(31)=AMIN1(AMAX1(E(1),0.),E(7)-1.)   
      A(32)=E(7)
C   
C ENCODE AND PACK PATTERSON 
C   
      L=0   
        DO 44 I=1,8 
  44    IP(I)=0 
      I=MB  
      MQ=0  
      NK=0  
  45  L=L+1 
        DO 48 J=1,51
        READ(LB)M,N,IN  
        IF(N.NE.J)GOTO 25   
        IF(M.NE.L)GOTO 25   
          DO 48 K=1,51  
            DO 46 M=1,7 
            IF(E(M).GT.FLOAT(IN(K)))GOTO 47 
  46        CONTINUE
          M=8   
  47      IP(M)=IP(M)+1 
          MQ=MQ*8+M-1   
          NK=NK+1   
          IF(NK.LT.MD)GOTO 48   
          A(I)=FLOAT(MQ)+0.3
          NK=0  
          MQ=0  
          I=I+1 
  48      CONTINUE  
      IF(NK.EQ.0)GOTO 49
      A(I)=FLOAT(MQ*8**(MD-NK))+0.3 
      NK=0  
      MQ=0  
      I=I+1 
  49  IF(I.NE.MP+1)GOTO 45  
        DO 50 I=1,8 
  50    IN(I)=I-1   
      N=0   
      J=NS*10   
      IF(IP(2).LT.NS)N=N+1  
        DO 51 I=3,8 
        IF(IP(I).LT.NS)N=N+1
        IF(IABS(IP(I)-IP(I-1)).GT.J)N=N+1   
  51    CONTINUE
      WRITE(LI,27)  
      IF(MX.EQ.0)WRITE(LI,28)   
      WRITE(LI,29)(E(I),I=1,7),(IN(I),I=1,8),(IP(I),I=1,8)  
      IF(A(24).GT.0.5)WRITE(LI,30)  
      IF(N.GT.0)WRITE(LI,31)
C   
C SELECT REPRESENTATIVE ATOMS   
C   
      M=MIN0(MAX0(MY/5,10),50)  
      IF(M.GT.MY)M=MY   
      N=MIN0(MAX0(MU/5,10),50)  
      IF(N.GT.MU)N=MU   
      IF(M+N.LT.51)GOTO 53  
      IF(M.LT.N)GOTO 52 
      N=N-(M+N-50)*MU/(MY+MU)   
      M=50-N
      GOTO 53   
  52  M=M-(M+N-50)*MY/(MY+MU)   
      N=50-M
  53  MU=M  
      MV=M+1
      MW=M+N
      MO=MIN0(MY,5) 
        DO 54 I=1,51
  54    IN(I)=0 
      IJ=1  
      K=0   
      L=1   
      NK=MU 
      IF(MZ.EQ.2)GOTO 56
        DO 55 I=2,4 
  55    G(I)=1. 
      GOTO 58   
  56    DO 57 I=2,4 
  57    G(I)=A(I+6) 
  58  S=0.  
      T=-1. 
  59    DO 60 I=LK,LX,8 
        IF(INT(A(I+7)+0.1).NE.L)GOTO 60 
        IF(A(I+1).LT.S)GOTO 60  
        U=A(I+2)*A(I+2)*G(2)+A(I+3)*A(I+3)*G(3)+
     +  A(I+4)*A(I+4)*G(4)  
        IF(U.LT.T)GOTO 60   
        T=U 
        J=I 
  60    CONTINUE
      IF(T.GT.-0.1)GOTO 61  
      S=-100.   
      GOTO 59   
  61  K=K+1 
      IF(K.LE.MO)IO(K)=J
      NC=K  
      N=IJ-1
  62  N=N+1 
      IF(N.EQ.K)GOTO 64 
      IF(IN(N).LT.J)GOTO 62 
  63  IN(NC)=IN(NC-1)   
      NC=NC-1   
      IF(NC.GT.N)GOTO 63
  64  IN(NC)=J  
      IF(K.EQ.NK)GOTO 69
      S=0.  
      T=-1. 
  65    DO 68 I=LK,LX,8 
        IF(INT(A(I+7)+0.1).NE.L)GOTO 68 
        IF(A(I+1).LT.S)GOTO 68  
          DO 66 M=IJ,K  
          IF(IN(M).EQ.I)GOTO 68 
  66      CONTINUE  
        U=9.E9  
          DO 67 M=IJ,K  
          N=IN(M)   
          R=G(2)*(A(I+2)-A(N+2))**2+G(3)*(A(I+3)-A(N+3))**2+
     +    G(4)*(A(I+4)-A(N+4))**2   
          U=AMIN1(R,U)  
  67      CONTINUE  
        IF(U.LT.T)GOTO 68   
        T=U 
        J=I 
  68    CONTINUE
      IF(T.GT.-0.1)GOTO 61  
      S=-100.   
      GOTO 65   
  69  IF(MI*L.NE.7)GOTO 71  
      L=2   
      IJ=MV 
      NK=MW 
      IF(MZ.EQ.2)GOTO 58
        DO 70 I=2,4 
  70    G(I)=A(I+6) 
      GOTO 58   
  71  WRITE(LI,75)MU
      IF(A(41).GT.0.)GOTO 73
        DO 72 K=1,MU
        I=IN(K) 
        CALL UNPACK(A(I),IC)
  72    WRITE(LI,76)IC  
      WRITE(LI,76)  
  73  IF(MI.EQ.4)GOTO 79
      M=MW-MU   
      WRITE(LI,77)M 
      IF(A(41).GT.0.)GOTO 79
        DO 74 K=MV,MW   
        I=IN(K) 
        CALL UNPACK(A(I),IC)
  74    WRITE(LI,76)IC  
  75  FORMAT(///' ATOMS USED FOR ROUGH PACKING TESTS:'/ 
     +I6,' FROM FRAGMENT 1')
  76  FORMAT(7X,4A1)
  77  FORMAT(I6,' FROM FRAGMENT 2') 
  78  FORMAT(///' SHORTEST INTERMOLECULAR DISTANCE BETWEEN',
     +' FIXED FRAGMENTS =',F6.2,' A')   
C   
C CALCULATE SOME PARAMETERS 
C   
  79  IF(MJ.EQ.0)GOTO 84
      S=9.E9
        DO 83 I=LK,LX,8 
        IF(INT(A(I+7)+0.1).NE.0)GOTO 83 
          DO 82 L=I,LX,8
          IF(INT(A(L+7)+0.1).NE.0)GOTO 82   
          NX=LY+16  
            DO 81 J=65,LY,12
            X=A(J)*A(L+2)+A(J+1)*A(L+3)+A(J+2)*A(L+4)+A(J+9)
            Y=A(J+3)*A(L+2)+A(J+4)*A(L+3)+A(J+5)*A(L+4)+A(J+10) 
            Z=A(J+6)*A(L+2)+A(J+7)*A(L+3)+A(J+8)*A(L+4)+A(J+11) 
            K=NX
  80        IF(K.GT.LL)GOTO 81  
            P=AMOD(A(K+1)+X*A(K)-A(I+2),1.)-0.5 
            Q=AMOD(A(K+2)+Y*A(K)-A(I+3),1.)-0.5 
            R=AMOD(A(K+3)+Z*A(K)-A(I+4),1.)-0.5 
            T=P*P*A(8)+Q*Q*A(9)+R*R*A(10)+Q*R*A(11)+P*R*A(12)+  
     +      P*Q*A(13)   
            S=AMIN1(S,T)
            K=K+4   
            GOTO 80 
  81        NX=LY+12
  82      CONTINUE  
  83    CONTINUE
      IF(S.GT.1.E9)S=1.E-6  
      T=SQRT(S) 
      WRITE(LI,78)T 
  84  A(24)=0.  
      LW=LH-2   
      MX=LH+3   
      IF(MK.NE.65)GOTO 85   
      A(41)=0.  
      A(42)=0.  
      GOTO 87   
  85    DO 86 I=LK,LX,8 
        IF(A(I+1).GT.0.)GOTO 87 
  86    CONTINUE
      A(41)=0.  
  87  A(41)=A(41)*A(41) 
      A(42)=A(42)*A(42) 
        DO 88 I=61,63   
  88    A(I)=0. 
      IF(ABS(A(51)).LT.0.5)GOTO 90  
      IF(A(52).LT.0.)GOTO 90
        DO 89 I=65,LY,12
        U=A(I+4)*A(I+8)-A(I+5)*A(I+7)   
        V=A(I+5)*A(I+6)-A(I+3)*A(I+8)   
        W=A(I+3)*A(I+7)-A(I+4)*A(I+6)   
        S=A(I)*U+A(I+1)*V+A(I+2)*W  
        IF(S.LT.0.)A(I+9)=A(I+9)+10.
  89    CONTINUE
  90    DO 91 I=1,5 
  91    E(I)=0. 
      IF(INT(A(25)).EQ.1)E(5)=1.
      I=ML+3
      J=I+1 
      IF(J.GT.4)J=J-3   
      K=J+1 
      IF(K.GT.4)K=K-3   
      IF(A(29).GT.0.)GOTO 92
      M=J   
      J=K   
      K=M   
  92  T=A(I)/A(36)+A(J)/A(37)+A(K)/A(38)
      E(6)=AMIN1(AMAX1(0.33*T,0.4),0.7) 
      IF(ABS(A(51)).LT.0.5)GOTO 94  
      E(4)=6.2831853
      IF(ABS(A(58))+ABS(A(59))+ABS(A(60)).LT.0.001)GOTO 94  
      E(4)=E(4)/10. 
        DO 93 I=1,3 
  93    E(I)=A(I+57)-0.5*E(4)   
  94  RETURN
      END   
C   
C --------------------------------------------------------------
C   
      SUBROUTINE PATSC  
C   
C PREPARE MODEL GEOMETRY FOR SEARCHES   
C   
C ** NEXT STATEMENT MUST HAVE C IN COLUMN 1 IF NOT FORTRAN-77 **
      CHARACTER*1 IH,IT 
C   
CMB
      include 'PATSEE.INC'
C   
C ANALYSE FLEXIBLE FRAGMENT 
C   
      T=E(12)*E(12) 
      IF(A(25).LT.0.5)GOTO 8
      IF(A(28).GT.0.5)GOTO 2
      I=LW  
   1  I=I+5 
      IF(A(I).LT.-0.5)GOTO 1
      A(60)=1.74533E-2*(A(I+4)-E(9))
      E(9)=A(I+4)   
      GOTO 30   
   2  E(9)=E(9)+E(10)   
      IF(LW.GT.LH)GOTO 29   
      J=INT(E(8)+0.1)   
      IF(J.GT.LX)GOTO 3 
      I=J-8 
      IF(INT(A(I+7)+0.1).NE.1)GOTO 3
      IF(INT(A(J+7)+0.1).EQ.1)GOTO 4
   3  WRITE(LI,21)  
      STOP  
   4  A(J+6)=-A(J+6)
      X=A(J+2)-A(I+2)   
      Y=A(J+3)-A(I+3)   
      Z=A(J+4)-A(I+4)   
      S=X*X+Y*Y+Z*Z 
      IF(S.GT.0.01)GOTO 5   
      WRITE(LI,22)  
      STOP  
   5  IF(S.GT.T)WRITE(LI,23)
      IF(S-X*X.GT.0.0001)GOTO 6 
      A(58)=0.  
      GOTO 7
   6  A(58)=ATAN2(Y,Z)  
      Z=Y*SIN(A(58))+Z*COS(A(58))   
   7  A(59)=-ATAN2(X,Z) 
      GOTO 9
   8  IF(LW.GT.LH)GOTO 36   
   9  LV=LH+3   
      N=1   
      NK=1  
        DO 12 K=LK,LX,8 
        IF(INT(A(K+7)+0.1).NE.1)GOTO 12 
        LW=LW+5 
        A(LW)=A(K+1)
        A(LW+1)=A(K+2)  
        A(LW+2)=A(K+3)  
        A(LW+3)=A(K+4)  
        A(LW+4)=A(K+6)  
        IF(IN(NK).NE.K)GOTO 11  
        IQ(NK)=LW   
        NK=NK+1 
          DO 10 II=1,MO 
          IF(IO(II).EQ.K)IO(II)=LW  
  10      CONTINUE  
  11    IF(E(12).GT.0.)GOTO 12  
        IF(K.LE.J)GOTO 12   
        A(LW+4)=-A(LW+4)
        N=N+1   
  12    CONTINUE
      LO=LW 
      MX=LW+5   
      IF(IABS(MZ-6).EQ.1)MX=MX+5*INT(ABS(A(52))+0.1)
      IF(A(25).LT.0.5)GOTO 36   
      A(J+6)=ABS(A(J+6))
        DO 13 J=LV,LW,5 
        IF(A(J+4).LT.0.)GOTO 14 
  13    CONTINUE
  14  E(8)=FLOAT(J) 
      IF(E(12).LT.0.)GOTO 28
        DO 15 K=LV,LW,5 
        IF(K.EQ.J)GOTO 15   
        IF(K.EQ.J-5)GOTO 15 
        S=(A(K+1)-A(J+1))**2+(A(K+2)-A(J+2))**2+
     +  (A(K+3)-A(J+3))**2  
        IF(S.GT.T)GOTO 15   
        N=N+1   
        A(K+4)=-A(K+4)  
  15    CONTINUE
      A(J+4)=ABS(A(J+4))
  16  M=N   
        DO 18 K=LV,LW,5 
        IF(A(K+4).GT.0.)GOTO 18 
          DO 17 L=LV,LW,5   
          IF(A(L+4).LT.0.)GOTO 17   
          IF(L.EQ.J)GOTO 17 
          S=(A(K+1)-A(L+1))**2+(A(K+2)-A(L+2))**2+  
     +    (A(K+3)-A(L+3))**2
          IF(S.GT.T)GOTO 17 
          N=N+1 
          A(L+4)=-A(L+4)
  17      CONTINUE  
  18    CONTINUE
      IF(N-M)28,28,16   
  19  WRITE(LI,24)  
      STOP  
  20  WRITE(LI,25)  
      STOP  
  21  FORMAT(//' ** FLEXIBLE BOND NOT PART OF FRAGMENT 1'///)   
  22  FORMAT(//' ** FLEXIBLE BOND SHORTER THAN 0.1 A'///)   
  23  FORMAT(//' ** FLEXIBLE BOND LONGER THAN 2.0 A'/)  
  24  FORMAT(//' ** FLEXIBLE BOND DOES NOT CONNECT TWO GROUPS', 
     +' OF ATOMS'///)   
  25  FORMAT(//' ** ATOMIC GROUPS CONNECTED BY MORE THAN ONE',  
     +' BOND - NO FREE ROTATION POSSIBLE'///)   
  26  FORMAT(//' GROUP WITH FREE ROTATION CONSISTS OF',I5,  
     +' ATOMS'/)
  27  FORMAT(//' TORSION ANGLE =',F6.0,' DEGREES REJECTED', 
     +' BECAUSE OF',I5,' CLOSE CONTACTS')   
  28  IF(A(J-1).LT.0.)GOTO 20   
      IF(N.GT.MY-2)GOTO 19  
      IF(N.EQ.1)GOTO 19 
      IF(E(12).LT.0.)A(J+4)=ABS(A(J+4)) 
      WRITE(LI,26)N 
      A(60)=1.74533E-2*E(9) 
      GOTO 30   
  29  A(60)=1.74533E-2*E(10)
C   
C ROTATE ABOUT FLEXIBLE BOND
C   
  30  N=INT(E(8)+0.1)-5 
        DO 33 L=LV,LW,5 
        IF(A(L+4).GT.0.)GOTO 33 
        G(1)=A(L+1)-A(N+1)  
        G(2)=A(L+2)-A(N+2)  
        G(3)=A(L+3)-A(N+3)  
        J=1 
        K=2 
          DO 31 I=58,60 
          J=J+1 
          IF(J.GT.3)J=J-3   
          K=K+1 
          IF(K.GT.3)K=K-3   
          U=COS(A(I))   
          V=SIN(A(I))   
          W=G(J)
          G(J)=W*U-G(K)*V   
  31      G(K)=W*V+G(K)*U   
          DO 32 M=1,2   
          I=60-M
          J=J-1 
          IF(J.LT.1)J=J+3   
          K=K-1 
          IF(K.LT.1)K=K+3   
          U=COS(A(I))   
          V=-SIN(A(I))  
          W=G(J)
          G(J)=W*U-G(K)*V   
  32      G(K)=W*V+G(K)*U   
        A(L+1)=G(1)+A(N+1)  
        A(L+2)=G(2)+A(N+2)  
        A(L+3)=G(3)+A(N+3)  
  33    CONTINUE
      A(25)=A(25)-1.
      IF(A(28).LT.0.5)GOTO 41   
      IF(ABS(E(12)).LT.0.2)GOTO 36  
      IF(ABS(A(60)).LT.0.01)GOTO 36 
      J=0   
        DO 35 K=LV,LW,5 
        IF(A(K+4).GT.0.)GOTO 35 
          DO 34 L=LV,LW,5   
          IF(A(L+4).LT.0.)GOTO 34   
          IF(L.EQ.N)GOTO 34 
          IF(L.EQ.N+5)GOTO 34   
          S=(A(K+1)-A(L+1))**2+(A(K+2)-A(L+2))**2+  
     +    (A(K+3)-A(L+3))**2
          IF(S.LT.T)J=J+1   
  34      CONTINUE  
  35    CONTINUE
      IF(J.EQ.0)GOTO 36 
      WRITE(LI,27)E(9),J
      IF(A(25).GT.0.5)GOTO 2
      IF(MZ.EQ.6)STOP   
      A(25)=-10.
      GOTO 43   
C   
C APPLY ORIGIN SHIFT
C   
  36  IF(ABS(A(51)).LT.0.5)GOTO 41  
        DO 37 I=1,3 
  37    G(I)=0. 
        DO 38 I=LV,LW,5 
        G(1)=G(1)+A(I+1)
        G(2)=G(2)+A(I+2)
  38    G(3)=G(3)+A(I+3)
      S=FLOAT(MY)   
        DO 39 I=1,3 
        G(I)=G(I)/S 
  39    A(I+60)=A(I+60)+G(I)
        DO 40 I=LV,LW,5 
        A(I+1)=A(I+1)-G(1)  
        A(I+2)=A(I+2)-G(2)  
  40    A(I+3)=A(I+3)-G(3)  
      A(24)=1.  
      GOTO 43   
  41  IF(A(24).LT.0.5)GOTO 43   
        DO 42 I=LV,LW,5 
        A(I+1)=A(I+1)+A(61) 
        A(I+2)=A(I+2)+A(62) 
  42    A(I+3)=A(I+3)+A(63) 
      A(24)=0.  
  43  RETURN
      END   
C   
C --------------------------------------------------------------
C   
      SUBROUTINE PATSD  
C   
C ROTATION SEARCH   
C   
C ** NEXT STATEMENT MUST HAVE C IN COLUMN 1 IF NOT FORTRAN-77 **
      CHARACTER*1 IH,IT,IC,ID   
C   
CMB
      include 'PATSEE.INC'
      DIMENSION IM(13),IC(4),ID(4)  
C   
C PRINT MODEL GEOMETRY  
C   
CMB   NROTS Anzahl der getesteten Rotationsloesungen 
      NROTS=0 
      IF(A(25).LT.-5.)GOTO 107  
      IF(A(51).GT.0.)GOTO 10
      A(51)=ABS(A(51))  
      WRITE(LI,6)   
        DO 4 I=LK,LX,8  
        IF(INT(A(I+7)+0.1).NE.1)GOTO 4  
        CALL UNPACK(A(I),IC)
        WRITE(LI,7) 
        NF=0
          DO 3 J=LK,LX,8
          IF(J.EQ.I)GOTO 3  
          IF(INT(A(J+7)+0.1).NE.1)GOTO 3
          Q=(A(J+2)-A(I+2))**2+(A(J+3)-A(I+3))**2+  
     +    (A(J+4)-A(I+4))**2
          IF(Q.GT.4.)GOTO 3 
          CALL UNPACK(A(J),ID)  
          NF=MIN0(NF+1,13)  
          IM(NF)=J  
          G(1)=SQRT(Q)  
          L=0   
   1      L=L+1 
          IF(L.GE.NF)GOTO 2 
          K=IM(L)   
          U=(A(K+2)-A(I+2))**2+(A(K+3)-A(I+3))**2+  
     +    (A(K+4)-A(I+4))**2
          W=0.5*(Q+U-(A(K+2)-A(J+2))**2-(A(K+3)-A(J+3))**2- 
     +    (A(K+4)-A(J+4))**2)/SQRT(Q*U) 
          G(L+1)=57.29578*ATAN2(SQRT(ABS(1.-W*W)),W)
          GOTO 1
   2      WRITE(LI,7)IC,ID,(G(K),K=1,NF)
   3      CONTINUE  
        IF(NF.EQ.0)WRITE(LI,8)IC
   4    CONTINUE
   5  FORMAT('1'//' ROTATION SEARCH FOR ',40A1)
CMB 
501   FORMAT('  ROTATION SEARCH FOR ',40A1/) 
   6  FORMAT(////' BOND LENGTHS AND ANGLES FOR FRAGMENT 1'/)
   7  FORMAT(2(1X,4A1),F7.3,12F7.1) 
   8  FORMAT(1X,4A1,4X,'** NO BONDS SHORTER THAN 2.0 A')
   9  FORMAT(/6X,'- TORSION ANGLE =',F6.0,' DEGREES -') 
C   
C SET UP VECTOR LIST
C   
  10  WRITE(LI,5)IT
CMB
      WRITE(*,501)IT 
CMB
      IF(A(25).GT.0.01)WRITE(LI,9)E(9)  
      IF(E(4).LT.6.)WRITE(LI,112)   
      E(11)=AMIN1(0.5*A(51)/(ABS(A(52))+3.),1000.)  
      IF(A(51).LT.1000.)E(11)=0.
      JR=MX-5   
      JA=1  
      IF(E(4).LT.6.)JA=0
      MT=MX+5*INT(ABS(A(52))+0.1)+15
      MR=MT-4   
      NF=MR+6000
      MS=0  
      NN=0  
      NC=0  
      VS=A(53)*A(53)
      DS=E(6)*E(6)  
        DO 17 I=LV,LW,5 
          DO 16 J=I,LW,5
          IF(J.EQ.I)GOTO 16 
          MS=MS+1   
          P=ABS(A(I+4)*A(J+4))  
          X=A(J+1)-A(I+1)   
          Y=A(J+2)-A(I+2)   
          Z=A(J+3)-A(I+3)   
          Q=X*X+Y*Y+Z*Z 
          IF(Q.GT.VS)GOTO 16
          IF(A(53).LT.0.)GOTO 11
          IF(Q.LT.4.)GOTO 16
  11      NN=NN+1   
          K=MT-4
  12      K=K+4 
          IF(K.GT.MR)GOTO 15
          S=1.  
  13      U=A(K+1)-X*S  
          V=A(K+2)-Y*S  
          W=A(K+3)-Z*S  
          IF(U*U+V*V+W*W.GT.DS)GOTO 14  
          W=P+A(K)  
          P=P*S 
          A(K+1)=(A(K+1)*A(K)+X*P)/W
          A(K+2)=(A(K+2)*A(K)+Y*P)/W
          A(K+3)=(A(K+3)*A(K)+Z*P)/W
          A(K)=W
          GOTO 16   
  14      S=-S  
          IF(S)13,12,12 
  15      IF(MR.GE.LM-7)GOTO 16 
          MR=MR+4   
          A(MR)=P   
          A(MR+1)=X 
          A(MR+2)=Y 
          A(MR+3)=Z 
  16      CONTINUE  
  17    CONTINUE
      IF(MR.GE.LM-7)NC=1
        DO 21 I=MT,MR,4 
          DO 20 J=I,MR,4
          IF(J.EQ.I)GOTO 20 
          S=1.  
  18      U=A(I+1)-S*A(J+1) 
          V=A(I+2)-S*A(J+2) 
          W=A(I+3)-S*A(J+3) 
          IF(U*U+V*V+W*W.GT.DS)GOTO 19  
          W=A(I)+A(J)   
          P=A(J)*S  
          A(J+1)=(A(I)*A(I+1)+P*A(J+1))/W   
          A(J+2)=(A(I)*A(I+2)+P*A(J+2))/W   
          A(J+3)=(A(I)*A(I+3)+P*A(J+3))/W   
          A(J)=W
          A(I)=0.   
          GOTO 21   
  19      S=-S  
          IF(S.LT.0.)GOTO 18
  20      CONTINUE  
  21    CONTINUE
      S=ABS(A(53))  
      WRITE(LI,22)MS,NN,S   
      IF(A(53).GT.0.)WRITE(LI,23)   
  22  FORMAT(//I7,' INTRAMOLECULAR VECTORS REDUCED TO',I6,  
     +' BY MAXIMUM LENGTH (',F4.1,' A)')
  23  FORMAT(8X,'- VECTORS SHORTER THAN 2.0 A ALSO REJECTED -') 
  24  FORMAT(/8X,'FURTHER REDUCED TO',I5,' BY COMBINATION OF',  
     +' VECTORS CLOSER THAN',F5.2,' A') 
  25  FORMAT(/I7,' VECTORS WITH LOW WEIGHT IGNORED (MINIMUM',   
     +' VECTOR WEIGHT =',F7.0,')')  
  26  FORMAT(//8X,'WEIGHT      X       Y       Z      LENGTH'/) 
  27  FORMAT(6X,F8.0,1X,3F8.3,F9.2) 
  28  FORMAT(/I7,' VECTORS USED FOR RFOM')  
  29  FORMAT(/8X,'SOLUTIONS WITH EQUIVALENT ATOMS CLOSER',  
     +' THAN',F4.1,' A REGARDED AS SIMILAR')
C   
C SORT AND PRINT VECTORS
C   
      K=0   
      I=MT  
  30  J=I   
      WS=0. 
  31  IF(A(J).LT.WS)GOTO 32 
      WS=A(J)   
      K=J   
  32  J=J+4 
      IF(J.LT.MR+1)GOTO 31  
      L=K+3 
        DO 33 J=K,L 
        P=A(J)  
        A(J)=A(I)   
        A(I)=P  
  33    I=I+1   
      IF(I.LT.MR)GOTO 30
  34  IF(A(MR).GT.0.01)GOTO 35  
      MR=MR-4   
      GOTO 34   
  35  J=(MR+4-MT)/4 
      WRITE(LI,24)J,E(6)
      IF(J.GT.0)GOTO 37 
      WRITE(LI,36)  
      IF(MZ.GT.4)GOTO 106   
      STOP  
  36  FORMAT(/' ** NO VECTORS'///)  
  37  M=0   
      IF(A(54).LT.0.)GOTO 40
      NN=MT+4   
      S=A(MT)/8.
        DO 38 I=NN,MR,4 
        IF(A(I).LT.S)GOTO 39
  38    CONTINUE
      GOTO 40   
  39  M=(MR+4-I)/4  
      MR=I-4
      J=J-M 
  40  IF(MR.GT.NF)NC=1  
      MR=MIN0(MR,NF)
      S=A(MR)   
      WRITE(LI,25)M,S   
      IF(A(27).GT.0.)GOTO 42
      WRITE(LI,26)  
        DO 41 I=MT,MR,4 
        Q=SQRT(A(I+1)**2+A(I+2)**2+A(I+3)**2)   
  41    WRITE(LI,27)A(I),A(I+1),A(I+2),A(I+3),Q 
  42  MS=MAX0(INT(AMIN1(ABS(A(27))*FLOAT(J)+0.5,A(28))),1)  
      A(57)=(A(32)-A(31))/(7.*A(21)*FLOAT(MS))  
      IF(NC.GT.0)WRITE(LI,111)  
      WRITE(LI,28)MS
C   
C INITIATE SEARCH   
C   
      RN=0.4321 
      S=AMOD(A(51)+0.25,0.5)-0.25   
      IF(ABS(S).GT.0.01)RN=RN+S 
      RV=E(4)   
      DS=A(54)*A(54)
      IF(DS.LT.9999.)GOTO 44
      S=-1. 
        DO 43 IS=1,MO   
        I=IO(IS)
  43    S=AMAX1(A(I+1)*A(I+1)+A(I+2)*A(I+2)+A(I+3)*A(I+3),S)
      DS=0.03*S 
  44  S=SQRT(DS)
      WRITE(LI,29)S 
      NF=0  
      A(MR+4)=-9.E9 
      MS=MS+MR+4
      RM=1.E-6  
      TN=E(11)*(ABS(A(52))+3.)*FLOAT(JA)+0.3
      MQ=MX-5   
      IF(JA.NE.1)GOTO 46
        DO 45 I=1,3
        G(I)=0. 
        G(I+3)=1.   
  45    G(I+6)=0.   
      GOTO 48   
  46    DO 47 I=1,3 
        RN=AMOD((1.+2.*AINT(1048576.*RN))*5.,2097152.)/2097152. 
        G(I)=E(I)+RV*AMOD(7169.*SQRT(RN),1.)
        IF(I*JA.EQ.3)G(I)=0.5*G(I)  
        G(I+3)=COS(G(I))
  47    G(I+6)=SIN(G(I))
  48  CONTINUE
      TN=TN+1.  
      NROTS=NROTS+1 
      IF(MOD(NROTS,1000).EQ.0)WRITE(*,481)NROTS,INT(A(51))
481   FORMAT('+',I10,' OUT OF ',I9,' RANDOM ORIENTATIONS TESTED')

        NN=MR+4   
        DO 60 I=MT,MR,4 
        X=A(I+2)*G(4)-G(7)*A(I+3)   
        Y=A(I+2)*G(7)+A(I+3)*G(4)   
        W=Y*G(5)-A(I+1)*G(8)
        Y=Y*G(8)+A(I+1)*G(5)
        U=Y*G(6)-X*G(9) 
        V=Y*G(9)+X*G(6) 
        W=A(17)*U+A(18)*V+A(19)*W   
        V=A(15)*U+A(16)*V   
        U=A(14)*U   
C   
C CALCULATE RFOM
C   
        NC=INT(A(30)+0.1)   
          DO 50 J=LJ,LS,9   
          TX=U*A(J)+V*A(J+1)+W*A(J+2)   
          TY=U*A(J+3)+V*A(J+4)+W*A(J+5) 
          TZ=U*A(J+6)+V*A(J+7)+W*A(J+8) 
            DO 50 K=LN,LH,3 
            PL=A(K)+TX  
            PA=A(K+1)+TY
            PD=A(K+2)+TZ
            L=INT(0.5+A(36)*AMOD(PL-A(33),1.))  
            IF(L.GE.NC)GOTO 49  
            M=INT(0.5+A(37)*AMOD(PA-A(34),1.))  
            IF(M.GT.50)GOTO 49  
            N=INT(0.5+A(38)*AMOD(PD-A(35),1.))  
            IF(N.LT.51)GOTO 52  
  49        L=INT(0.5+A(36)*AMOD(199.-PL-A(33),1.)) 
            IF(L.GE.NC)GOTO 50  
            M=INT(0.5+A(37)*AMOD(199.-PA-A(34),1.)) 
            IF(M.GT.50)GOTO 50  
            N=INT(0.5+A(38)*AMOD(199.-PD-A(35),1.)) 
            IF(N.LT.51)GOTO 52  
  50        CONTINUE
        WRITE(LI,51)U,V,W   
        STOP
  51    FORMAT(/' ** BAD VECTOR:',3F8.4///) 
  52    M=M+N*51
        L=MB+MC*L+M/MD  
        M=INT(A(L))/8**(MD-MOD(M,MD)-1) 
        P=(FLOAT(MOD(M,8))+0.3)/A(I)
        M=NN+1  
        L=M 
  53    L=L-1   
        IF(A(L).GT.P)GOTO 53
        IF(L.EQ.MS)GOTO 60  
        GOTO 55 
  54    A(M+1)=A(M) 
  55    M=M-1   
        IF(M.GT.L)GOTO 54   
        A(L+1)=P
        NN=NN+1 
        IF(NN-MS)60,57,56   
  56    WS=WS+A(57)*(P-A(NN))   
        NN=NN-1 
        GOTO 59 
  57    WS=0.   
        NC=MR+4 
  58    NC=NC+1 
        WS=WS+A(NC) 
        IF(NC.LT.MS)GOTO 58 
        WS=WS*A(57) 
  59    IF(WS.LT.RM)GOTO 86 
  60    CONTINUE
C   
C OVERLAP TEST  
C   
      NF=NF+1   
        DO 64 II=1,MU   
        I=IQ(II)
        S=1.
        IF(A(I).LT.0.)S=-1. 
        X=A(I+2)*G(4)-G(7)*A(I+3)   
        Y=A(I+2)*G(7)+G(4)*A(I+3)   
        Z=Y*G(5)-A(I+1)*G(8)
        Y=Y*G(8)+A(I+1)*G(5)
        U=Y*G(6)-X*G(9) 
        V=Y*G(9)+X*G(6) 
        PZ=A(17)*U+A(18)*V+A(19)*Z  
        PY=A(15)*U+A(16)*V  
        PX=A(14)*U  
          DO 63 J=LZ,LQ,4   
          TX=A(J+1)+PX  
          TY=A(J+2)+PY  
          TZ=A(J+3)+PZ  
            DO 62 IS=II,MU  
            K=IQ(IS)
            IF(K.EQ.I)GOTO 62   
            IF(S.GT.0.)GOTO 61  
            IF(A(K).LT.0.)GOTO 62   
  61        X=A(K+2)*G(4)-G(7)*A(K+3)   
            Y=A(K+2)*G(7)+G(4)*A(K+3)   
            Z=Y*G(5)-A(K+1)*G(8)
            Y=Y*G(8)+A(K+1)*G(5)
            U=Y*G(6)-X*G(9) 
            V=Y*G(9)+X*G(6) 
            PL=A(17)*U+A(18)*V+A(19)*Z  
            PA=A(15)*U+A(16)*V  
            PD=A(14)*U  
            Z=AMOD(TZ-PL,1.)-0.5
            V=AMOD(TY-PA,1.)-0.5
            U=AMOD(TX-PD,1.)-0.5
            IF(ABS(Z+PL-PZ)+ABS(V+PA-PY)+ABS(U+PD-PX)   
     +      .LT.0.01)GOTO 62
            IF(U*U*A(8)+V*V*A(9)+Z*Z*A(10)+V*Z*A(11)+   
     +      U*Z*A(12)+U*V*A(13).LT.4.)GOTO 86   
  62        CONTINUE
  63      CONTINUE  
  64    CONTINUE
      NF=NF-1   
C   
C EQUIVALENCE CHECK 
C   
      IF(JA.LT.2)GOTO 65
      I=JR  
      RM=WS 
      GOTO 85   
  65  NC=0  
      I=MX-5
  66  I=I+5 
      IF(I.GT.MQ)GOTO 76
      J=I+1 
        DO 67 K=1,3 
        IF(ABS(A(J)-G(K)).GT.0.15)GOTO 68   
  67    J=J+1   
      A(I+4)=A(I+4)+1.  
      IF(WS.LT.A(I))GOTO 86 
      IF(NC.NE.0)GOTO 77
      NC=I  
      GOTO 66   
  68  S=1.  
  69    DO 75 K=65,LY,12
        IF(A(52).LT.0.)GOTO 71  
        IF(S.LT.0.)GOTO 70  
        IF(A(K+9)-5.)71,71,75   
  70    IF(A(K+9).LT.5.)GOTO 75 
  71      DO 74 IS=1,MO 
          J=IO(IS)  
          NN=J+1
            DO 72 L=10,12   
            G(L)=A(NN)  
            G(L+3)=A(NN)
  72        NN=NN+1 
          M=10  
          N=11  
          NN=I+1
            DO 73 NX=4,6
            P=COS(A(NN))
            Q=SIN(A(NN))
            M=M+1   
            IF(M.GT.12)M=M-3
            N=N+1   
            IF(N.GT.12)N=N-3
            T=G(M)*P-G(N)*Q 
            G(N)=G(M)*Q+G(N)*P  
            G(M)=T  
            T=G(M+3)*G(NX)-G(N+3)*G(NX+3)   
            G(N+3)=G(M+3)*G(NX+3)+G(N+3)*G(NX)  
            G(M+3)=T
  73        NN=NN+1 
          G(15)=G(15)*A(19)+G(14)*A(18)+G(13)*A(17) 
          G(14)=G(14)*A(16)+G(13)*A(15) 
          G(13)=G(13)*A(14) 
          G(12)=G(12)*A(19)+G(11)*A(18)+G(10)*A(17) 
          G(11)=G(11)*A(16)+G(10)*A(15) 
          G(10)=G(10)*A(14) 
          X=G(13)*A(K)+G(14)*A(K+1)+G(15)*A(K+2)-G(10)*S
          Y=G(13)*A(K+3)+G(14)*A(K+4)+G(15)*A(K+5)-G(11)*S  
          Z=G(13)*A(K+6)+G(14)*A(K+7)+G(15)*A(K+8)-G(12)*S  
          IF(X*X*A(8)+Y*Y*A(9)+Z*Z*A(10)+Y*Z*A(11)+ 
     +    X*Z*A(12)+X*Y*A(13).GT.DS)GOTO 75 
  74      CONTINUE  
        A(I+4)=A(I+4)+1.
        IF(WS.LT.A(I))GOTO 86   
        IF(NC.NE.0)GOTO 77  
        NC=I
        GOTO 66 
  75    CONTINUE
      IF(S.LT.0.)GOTO 66
      S=-1. 
      GOTO 69   
  76  IF(NC.EQ.0)GOTO 80
      I=NC  
      GOTO 85   
  77  K=MQ+4
      IF(I.LT.MQ)GOTO 78
      J=I   
      I=NC  
      NC=J  
  78  A(I+4)=A(I+4)+A(NC+4)-1.  
        DO 79 J=MQ,K
        A(NC)=A(J)  
  79    NC=NC+1 
      MQ=MQ-5   
      RM=1.E-6  
      GOTO 85   
  80  IF(MQ+10.GT.MT)GOTO 81
      MQ=MQ+5   
      I=MQ  
      GOTO 84   
  81  RM=9.E9   
      J=MX-5
  82  J=J+5 
      IF(J.GT.MQ)GOTO 83
      IF(A(J).GT.RM)GOTO 82 
      RM=A(J)   
      I=J   
      GOTO 82   
  83  IF(RM.GT.WS)GOTO 86   
  84  A(I+4)=1.1
  85  A(I)=WS   
      A(I+1)=G(1)   
      A(I+2)=G(2)   
      A(I+3)=G(3)   
  86  IF(TN.LT.A(51))GOTO 46
      IF(JA.EQ.0)GOTO 90
      IF(E(11).LT.1.)GOTO 90
      JR=JR+5   
      IF(JR.GT.MQ)GOTO 88   
      TN=TN-E(11)   
      IF(RV.LT.1.)GOTO 87   
      RV=0.31416
      JA=2  
  87  E(1)=A(JR+1)-0.5*RV   
      E(2)=A(JR+2)-0.5*RV   
      E(3)=A(JR+3)-0.5*RV   
      RM=A(JR)  
      GOTO 46   
  88    DO 89 I=1,3 
  89    E(I)=0. 

      WRITE(*,481)INT(A(51)),INT(A(51))
C   
C SORT SOLUTIONS
C   
  90  I=MX  
  91  IF(I.GT.MQ-5)GOTO 98  
      Q=-9.E9   
      J=I-5 
  92  J=J+5 
      IF(J.GT.MQ)GOTO 93
      IF(A(J).LT.Q)GOTO 92  
      K=J   
      Q=A(J)
      GOTO 92   
  93    DO 94 J=1,5 
        Q=A(K)  
        A(K)=A(I)   
        A(I)=Q  
        I=I+1   
  94    K=K+1   
      GOTO 91   
  95  FORMAT(///I7,' RANDOM ORIENTATIONS TESTED'//I7,   
     +' SOLUTIONS WITH GOOD RFOM REJECTED BY OVERLAP TEST') 
  96  FORMAT(///8X,'RFOM    PHI1    PHI2    PHI3     HITS'//
     +(4X,4F8.3,F9.0))  
  97  FORMAT(//////////' SUMMARY OF BEST ROTATION SOLUTIONS:'/  
     +1X,35('*')//8X,'RFOM    PHI1    PHI2    PHI3   TORSION'/  
     +40X,'ANGLE'/(4X,4F8.3,F9.0))  
  98  L=MQ+4
      MQ=MIN0(MQ,MT-20) 
      K=MQ+4
      N=INT(A(51)+0.3)  
      WRITE(LI,95)N,NF  
      IF(K.GT.MX)GOTO 100   
      WRITE(LI,99)  
      IF(MZ.GT.4)GOTO 106   
      GOTO 109  
  99  FORMAT(/5X,'** NO ROTS SOLUTION'///)  
 100  WRITE(LI,96)(A(I),I=MX,K) 
      K=K+1 
      IF(L.GT.K)WRITE(LI,110)(A(I),I=K,L)   
      IF(MZ.EQ.1)GOTO 109   
      IF(MZ.GT.4)GOTO 101   
      MX=MT-15  
      LO=MQ 
      GOTO 108  
 101  I=LW  
      J=MX  
 102  I=I+5 
      IF(I.GT.MX-5)GOTO 106 
      IF(A(I).GT.A(J))GOTO 102  
      K=MX-6
 103  IF(K.LT.I)GOTO 105
        DO 104 N=1,5
        A(K+5)=A(K) 
 104    K=K-1   
      GOTO 103  
 105  A(I)=A(J) 
      A(I+1)=A(J+1) 
      A(I+2)=A(J+2) 
      A(I+3)=A(J+3) 
      A(I+4)=E(9)   
      LO=LO+5   
      J=J+5 
      IF(J.LT.MQ+4)GOTO 102 
 106  IF(A(25).GT.0.5)GOTO 114  
 107  IF(LO.LT.LW+5)GOTO 109
      IF(LO.GT.MX-5)LO=MX-5 
      J=LW+5
      K=LO+4
      IF(E(5).LT.0.5)WRITE(LI,97)(A(I),I=J,K)   
      IF(MZ.EQ.5)GOTO 109   
      A(25)=ABS(A(52))+0.1  
      A(28)=0.  
 108  A(51)=0.  
      WRITE(LI,113)MS   
      GOTO 114  
 109  IF(MS.GT.0)WRITE(LI,113)MS
      STOP  
 110  FORMAT(7X,38('-')/(4X,4F8.3,F9.0))
 111  FORMAT(/5X,'** NOT ALL VECTORS CONSIDERED BECAUSE OF',
     +' STORAGE PROBLEMS')  
 112  FORMAT(/8X,'SEARCH RESTRICTED TO A SMALL ANGULAR RANGE')  
 113  FORMAT(////' HIGHEST MEMORY USED FOR ROTATION SEARCH =',I7)   
 114  RETURN
      END   
C   
C --------------------------------------------------------------
C   
      SUBROUTINE PATSE  
C   
C TRANSLATION SEARCH
C   
C ** NEXT STATEMENT MUST HAVE C IN COLUMN 1 IF NOT FORTRAN-77 **
      CHARACTER*1 IH,IT,IC  
CMB
      CHARACTER*4 ATEMP
C   
CMB
      include 'PATSEE.INC'
      DIMENSION IC(4),B(19),C(1001),D(1001),F(1251) 

      NREFND=0
      NRTPRS=0
C   
C FIND TRIPLE PHASE RELATIONS   
C   
      NN=LW 
      TN=0. 
      IJ=0  
      NP=0  
        DO 1 J=1,1251   
   1    F(J)=SIN(6.2831853E-3*FLOAT(J-1))   
        DO 2 J=1,1001   
        D(J)=SIN(6.2831853E-6*FLOAT(J-1))   
   2    C(J)=COS(6.2831853E-6*FLOAT(J-1))   
      IF(A(24).LT.-0.5)GOTO 34  
   3  FORMAT('1'//' TRANSLATION SEARCH FOR ',40A1/)
CMB 
301   FORMAT('  TRANSLATION SEARCH FOR ',40A1) 
      WRITE(LI,3)IT
CMB
      WRITE(*,301)IT
CMB
      E(11)=0.  
      MS=MX 
      MT=MX-5+(3*(ME+4-NE)*(LY-53))/16  
      MR=MT 
      A(MX)=0.  
      A(MX+4)=0.
      L=NE-4
   4  L=L+4 
      Q=1.  
      Z=A(L)
      A(L+2)=0.1
      I=MX-4
      J=MS  
   5  I=I+4 
   6  IF(I.GT.J)GOTO 9  
      X=Z-A(I)-A(J) 
      IF(X.GT.0.5)GOTO 5
      IF(X.GT.-0.5)GOTO 7   
      J=J-4 
      GOTO 6
   7  IF(ABS(ABS(A(I+1))-ABS(A(J+1))).LT.0.5)GOTO 8 
      MR=MR+5   
      A(MR)=FLOAT(L)+2.1
      X=Q*A(I+1)
      A(MR+1)=X 
      A(MR+2)=A(J+1)
      M=INT(ABS(X)) 
      N=INT(ABS(A(MR+2)))   
      A(L+2)=A(L+2)+1.  
      A(M)=A(M)+1.  
      A(N)=A(N)+1.  
      U=SIGN(1.,X)*A(I+3)   
      V=SIGN(1.,A(J+1))*A(J+3)  
      A(MR+3)=A(I+2)*A(J+2)-U*V 
      A(MR+4)=A(I+2)*V+A(J+2)*U 
      IF(MR.GT.MT+5*INT(ABS(A(44))-0.9))GOTO 18 
   8  IF(Q)10,5,5   
   9  Q=-1. 
      I=MX  
      J=MX+4
  10  I=I+4 
  11  X=Z+A(I)-A(J) 
      IF(X.LT.-0.5)GOTO 10  
      IF(X.LT.0.5)GOTO 7
      J=J+4 
      IF(J.LE.MS)GOTO 11
      CALL HKL(A(L),X,Y,Z)  
        DO 15 J=65,LY,12
        P=6.2831853*(X*A(J+9)+Y*A(J+10)+Z*A(J+11))  
        Q=X*A(J)+Y*A(J+3)+Z*A(J+6)+200.*(X*A(J+1)+Y*A(J+4)+ 
     +  Z*A(J+7)+200.*(X*A(J+2)+Y*A(J+5)+Z*A(J+8))) 
        S=ABS(Q)+0.5
        K=MS+4  
        I=K 
  12    I=I-4   
        IF(A(I).GT.S)GOTO 12
        IF(A(I)-S+1.)14,15,15   
  13    A(K+4)=A(K) 
        A(K+5)=A(K+1)   
        A(K+6)=A(K+2)   
        A(K+7)=A(K+3)   
  14    K=K-4   
        IF(K.GT.I)GOTO 13   
        A(I+4)=S-0.5
        A(I+5)=SIGN(FLOAT(L)+2.1,Q) 
        A(I+6)=COS(P)   
        A(I+7)=SIN(P)   
        MS=MS+4 
  15    CONTINUE
      IF(L.LT.ME)GOTO 4 
  16  FORMAT(/' ** NOT ENOUGH TPR'///)  
  17  FORMAT(/I6,' TPR LINKING',I4,' E GREATER THAN',F6.3,  
     +' STORED'/7X,'- NOMINAL RESOLUTION OF E-VALUES:', 
     +F6.2,' A -')  
  18  IJ=(MR-MT)/5  
      MF=L  
      NP=(MF-NE+4)/4
      S=AMOD(A(MF+1),100.)  
      WRITE(LI,17)IJ,NP,S,A(1)  
      A(24)=-1. 
      A(43)=SIGN(1.,A(43))+4.   
      A(44)=0.2+SIGN(0.1,A(44))-A(23)*0.1   
      IF(A(39).GT.0.)GOTO 20
      A(39)=ABS(A(39))  
      WRITE(LI,21)  
        DO 19 I=NE,MF,4 
        CALL HKL(A(I),X,Y,Z)
        J=INT(X)
        K=INT(Y)
        L=INT(Z)
        M=INT(A(I+2))   
        S=AMOD(A(I+1),100.) 
  19    WRITE(LI,22)J,K,L,S,M   
  20  IF(IJ.GT.19)GOTO 26   
      IF(MK.EQ.65)GOTO 26   
      WRITE(LI,16)  
      STOP  
  21  FORMAT(//10X,'H   K   L     E    N(TPR)'/)
  22  FORMAT(7X,3I4,F8.3,I6)
  23  FORMAT(/I6,' INTERMOLECULAR VECTORS OUT OF',I8,   
     +' USED FOR TFOM') 
  24  FORMAT(/I6,' ATOMS WITH LOW SCATTERING POWER IGNORED')
  25  FORMAT(/4X,'** NO INTERMOLECULAR VECTORS WITH',   
     +' SIGNIFICANT WEIGHT')
  26    DO 27 I=NE,ME,4 
        S=AINT(A(I+1)/100.) 
        A(I+1)=AMOD(A(I+1),100.)*SQRT(S)
        E(14)=E(14)+A(I+1)  
  27    E(15)=E(15)+A(I+1)*A(I+1)   
C   
C COUNT AND SCALE VECTORS   
C   
        DO 28 I=1,3 
  28    G(I)=0. 
      WS=0. 
        DO 29 I=LK,LX,8 
        WS=WS+A(I+6)*A(I+6) 
        IF(A(I+6).LT.4.9)GOTO 29
        N=INT(A(I+7)+1.1)   
        G(N)=G(N)+1.
  29    CONTINUE
      I=INT(G(1)+0.1)   
      J=INT(G(2)+0.1)   
      M=INT(G(3)+0.1)   
      A(27)=SQRT(WS*FLOAT(LY-53)/12.)   
      N=(J*J+M*M+J+M)/2 
      K=(N+I*J+I*M+J*M)*(LY-53)*(LL-LY-8)/48-N  
      NV=MAX0(INT(AMIN1(ABS(A(55))*FLOAT(K)+0.5,A(56))),1)  
      IF(MK.EQ.65)GOTO 31   
      IF(A(56).LT.0.9999)GOTO 30
      IF(K.GT.0)WRITE(LI,23)NV,K
      N=(LX-LK+8)/8-I-J-M   
      IF(N.GT.0)WRITE(LI,24)N   
      IF(K.GT.0)GOTO 30 
      WRITE(LI,25)  
      A(55)=ABS(A(55))  
      A(56)=0.1 
  30  IF(A(56).GT.0.9999)GOTO 31
      WRITE(LI,60)  
      IN(51)=1  
  31  A(57)=(A(32)-A(31))/(7.*A(21))
      A(20)=A(57)/(FLOAT(LX-LK+8)*FLOAT(LY-53)* 
     +FLOAT(LL-LY-8)/384.-0.9999)   
      A(57)=A(57)/FLOAT(NV) 
      A(MR+5)=9.E9  
      MQ=MR+5+12*INT(ABS(A(40))+0.1)
      A(53)=0.  
        DO 32 I=65,LY,12
        IF(ABS(A(I+1))+ABS(A(I+2))+ABS(A(I+3))+ABS(A(I+5))+ 
     +  ABS(A(I+6))+ABS(A(I+7)).GT.0.5)A(53)=1. 
  32    CONTINUE
      E(6)=0.5  
      IF(INT(A(53)+0.1)+MI+MJ.NE.4)E(6)=1.  
      E(7)=-1.  
      IF(MJ.NE.0)GOTO 33
      E(7)=1.   
      IF(A(53).LT.0.5)GOTO 33   
      IF(LQ-LZ.EQ.12)GOTO 33
      E(7)=0.   
      IF(ABS(A(2)-A(3))+ABS(A(2)-A(4))+ABS(A(11))+  
     +ABS(A(12))+ABS(A(13)).LT.0.001)E(7)=-1.   
  33  IF(A(39).GT.0.9999)GOTO 34
      TN=A(2)*A(3)*A(4)/(A(1)*A(1)*A(1))
      IF(MI.EQ.7)TN=TN*SQRT(TN) 
      IF(E(7).GT.-0.5)TN=0.5*TN 
      IF(E(7).GT.0.5)TN=0.25*TN 
C   
C FIX ORIENTATION OF FRAGMENT 1 
C   
  34  RN=0.4321 
      S=AMOD(A(39)+0.25,0.5)-0.25   
      IF(ABS(S).GT.0.01)RN=RN+S 
      G(15)=0.  
      JR=0  
      IF(IABS(MZ-4).EQ.2)GOTO 36
  35  NN=NN+5   
      IF(A(NN).LT.-0.5)GOTO 35  
      JR=(NN-LW)/5-1
  36  JE=0  
      NT=0  
      NF=0  
      NQ=0  
        DO 37 I=1,19
  37    B(I)=0. 
      MS=MR+5   
      IF(MZ.EQ.2)GOTO 42
      IF(MZ.EQ.6)GOTO 39
      G(15)=A(NN)   
      L=NN  
        DO 38 I=8,10
        L=L+1   
        G(I)=SIN(A(L))  
  38    G(I+3)=COS(A(L))
      JR=JR+1   
  39  L=LV-4
        DO 41 M=LK,LX,8 
        IF(INT(A(M+7)+0.1).NE.1)GOTO 41 
        L=L+5   
        X=A(L)  
        Y=A(L+1)
        Z=A(L+2)
        IF(MZ.EQ.6)GOTO 40  
        Q=Y*G(11)-Z*G(8)
        S=Y*G(8)+Z*G(11)
        P=S*G(9)+X*G(12)
        Z=S*G(12)-X*G(9)
        X=P*G(13)-Q*G(10)   
        Y=P*G(10)+Q*G(13)   
  40    A(M+2)=A(14)*X  
        A(M+3)=A(15)*X+A(16)*Y  
        A(M+4)=A(17)*X+A(18)*Y+A(19)*Z  
  41    CONTINUE
C   
C PARTIAL E(CALC) COEFFICIENTS  
C   
  42  M=MX-9
      A(54)=0.  
        DO 47 I=NE,ME,4 
        CALL HKL(A(I),X,Y,Z)
        S=0.
        G(2)=0. 
        G(3)=0. 
          DO 46 J=65,LY,12  
          M=M+9 
          A(M)=X*A(J)+Y*A(J+3)+Z*A(J+6) 
          A(M+1)=X*A(J+1)+Y*A(J+4)+Z*A(J+7) 
          A(M+2)=X*A(J+2)+Y*A(J+5)+Z*A(J+8) 
          L=M+3 
          N=M+8 
            DO 43 K=L,N 
  43        A(K)=0. 
          T=X*A(J+9)+Y*A(J+10)+Z*A(J+11)
            DO 44 K=LK,LX,8 
            Q=(T+A(K+2)*A(M)+A(K+3)*A(M+1)+A(K+4)*A(M+2))   
     +      *6.2831853  
            NL=INT(A(K+7)*2.1)+M
            A(NL+3)=A(NL+3)+A(K+6)*COS(Q)   
  44        A(NL+4)=A(NL+4)+A(K+6)*SIN(Q)   
          L=M+5 
            DO 45 K=L,N 
  45        S=S+A(K)*A(K)   
          G(2)=G(2)+A(M+3)  
          G(3)=G(3)+A(M+4)  
  46      CONTINUE  
        S=S+(2.-A(23))*G(2)*G(2)+A(23)*G(3)*G(3)
        A(I+2)=SQRT(S)/(A(I+1)*A(27))   
        A(54)=A(54)+A(I+2)  
  47    CONTINUE
      A(54)=A(54)/FLOAT((ME-NE+4)/4)
      A(26)=0.  
      K=MT+5
        DO 48 N=K,MR,5  
        IF(A(N).GT.0.)A(N)=-A(N)
  48    CONTINUE
      Q=FLOAT((MR-MT)/5)
      IJ=0  
      T=1.6 
  49  T=T-0.1   
      S=T*A(54)*A(54)*A(54) 
      N=MT  
  50  N=N+5 
      IF(N.GT.MR)GOTO 51
      IF(A(N).GT.0.)GOTO 50 
      L=INT(ABS(A(N)))  
      I=INT(ABS(A(N+1)))
      J=INT(ABS(A(N+2)))
      IF(A(I)*A(J)*A(L).LT.S)GOTO 50
      A(N)=ABS(A(N))
      IJ=IJ+1   
      A(26)=A(26)+A(I-1)*A(J-1)*A(L-1)  
      GOTO 50   
  51  R=FLOAT(IJ)/Q 
      IF(R.LT.0.4)GOTO 49   
C   
C FIND INCREMENTS   
C   
      IF(MP.GT.MX)GOTO 56   
      S=A(1)*0.25   
        DO 53 I=45,47   
        A(I-40)=A(I-43) 
        A(I)=S/A(I-43)  
        A(I+3)=A(I) 
        IF(MJ.NE.0)GOTO 53  
        IF(A(23).LT.0.5)GOTO 53 
        L=4*(I-45)  
          DO 52 J=65,LY,12  
          K=J+L 
          IF(A(K).LT.0.9)GOTO 53
  52      CONTINUE  
        A(I)=0. 
        IF(TN.GT.0.5)TN=TN*A(1)*2./A(I-43)  
  53    CONTINUE
      IF(TN.GT.0.5)A(39)=AMIN1(FLOAT((INT(TN)/100+1)*100),  
     +99999.)   
      IF(MK.NE.65)GOTO 54   
      A(39)=1.  
      A(45)=1.E-4   
  54  N=INT(A(39)+0.1)  
      M=MIN0(INT(ABS(A(40))+0.1),N) 
      IF(MK.NE.65)WRITE(LI,61)N,M   
      MP=MQ+12+NV   
      IF(MK.EQ.65)GOTO 55   
      E(13)=0.1+(A(43)-3.)*0.05 
      N=INT(11./A(43))  
      S=A(44)+0.2   
      WRITE(LI,62)S,N   
      IF(A(55).LT.0.)WRITE(LI,58)   
  55  IF(MG.EQ.1)WRITE(LI,59)  
CMB Zusaetzliche Ausgabe auf Standardoutput  
  56  IF(IABS(MZ-4).NE.2)THEN
         WRITE(LI,63)JR,A(NN+1),A(NN+2),A(NN+3),G(15)
         WRITE(*,6301)JR,A(NN+1),A(NN+2),A(NN+3),G(15)
      ENDIF 
      IF(MZ.GT.4)WRITE(LI,64)E(9) 
      WRITE(LI,65)A(54),IJ  
        DO 57 I=2,7 
  57    G(I)=0. 
      GOTO 71   
  58  FORMAT(/7X,'TPRSUM NOT INCORPORATED INTO CFOM')   
  59  FORMAT(/7X,'RE(2) NOT INCORPORATED INTO CFOM')
  60  FORMAT(/7X,'FAST TRANSLATION SEARCH WITHOUT USING THE',   
     +' PATTERSON FUNCTION')
  61  FORMAT(/I6,' RANDOM POSITIONS REFINED FOR EACH',  
     +' ORIENTATION'//I6,' BEST SOLUTIONS KEPT')
  62  FORMAT(/7X,'SOLUTIONS WITH TPRSUM LESS THAN',F5.2,
     +' REJECTED AFTER',I2,' REFINEMENT CYCLES')
  63  FORMAT(////'  ROTS SOLUTION',I3,' (PHI1 =',F6.3,' / ',
     +'PHI2 =',F6.3,' / PHI3 =',F6.3,' / RFOM =',F6.3,')'/  
     +2X,76('*'))   
CMB
6301  FORMAT('   ROTS SOLUTION',I3,' (PHI1 =',F6.3,' / ',
     +'PHI2 =',F6.3,' / PHI3 =',F6.3,' / RFOM =',F6.3,')'/)  
  64  FORMAT(/5X,'- TORSION ANGLE =',F6.0,' DEGREES -') 
  65  FORMAT(/7X,'MEAN E(CALC)/E(OBS) =',F5.2//I6,' MOST',  
     +' TRANSLATION-SENSITIVE TPR USED FOR REFINEMENT') 
  66  FORMAT(//'   CFOM    X1    Y1    Z1     X2    Y2 ',   
     +'   Z2   RMIN  TPRSUM  TFOM  RE(1)/RE(2)'/)   
  67  FORMAT(F7.3,1X,3F6.3,1X,3F6.3,F6.2,3F7.3,'/',F5.3)
  68  IF(JZ.EQ.41)NQ=NQ+1   
      IF(JZ.EQ.42)NF=NF+1   
  69    DO 70 I=2,MI
        RN=AMOD((1.+2.*AINT(1048576.*RN))*5.,2097152.)/2097152. 
        G(I)=AMOD(7169.*SQRT(RN),1.)
        IF(A(I+43).LT.1.E-6)G(I)=0. 
  70    CONTINUE
      IF(E(7).GT.-0.5)G(4)=0.5*G(4) 
      IF(E(7).LT.0.5)GOTO 71
      G(2)=0.5*G(2) 
      G(3)=0.5*G(3)
CMB
      NREFND=NREFND+1
      
      IF(MOD(NREFND,10).EQ.0) WRITE(*,701)NREFND,NINT(A(39))
701   FORMAT('+',I10,' OUT OF ',I9,' RANDOM POSITIONS TESTED ')
702   FORMAT('+',I10,' OUT OF ',I9,' RANDOM POSITIONS TESTED '
     +       ,I5,' REJECTED')

CMB
  71  NT=NT+1   
      IF(NT.GT.INT(A(39)+0.1))GOTO 124  
C   
C SHORT DISTANCE TEST   
C   
      IF(A(41).LT.0.01)GOTO 78  
      S=9.E9
      JZ=41 
  72    DO 77 II=1,MW   
        I=IN(II)
        N=INT(3.1*A(I+7))   
        X=A(I+2)+G(N-1) 
        Y=A(I+3)+G(N)   
        Z=A(I+4)+G(N+1)
          DO 76 IS=II,MW
          L=IN(IS)  
          IF(A(I+1).GT.0.)GOTO 73   
          IF(A(L+1).LT.0.)GOTO 76   
  73      M=INT(3.1*A(L+7)) 
          U=A(L+2)+G(M-1)   
          V=A(L+3)+G(M) 
          W=A(L+4)+G(M+1)   
          NX=LY+16  
          IF(N.NE.M)NX=NX-4 
            DO 75 J=65,LY,12
            XS=A(J)*U+A(J+1)*V+A(J+2)*W+A(J+9)  
            YS=A(J+3)*U+A(J+4)*V+A(J+5)*W+A(J+10)   
            ZS=A(J+6)*U+A(J+7)*V+A(J+8)*W+A(J+11)   
            K=NX
  74        IF(K.GT.LL)GOTO 75  
            P=AMOD(A(K+1)+XS*A(K)-X,1.)-0.5 
            Q=AMOD(A(K+2)+YS*A(K)-Y,1.)-0.5 
            R=AMOD(A(K+3)+ZS*A(K)-Z,1.)-0.5 
            T=P*P*A(8)+Q*Q*A(9)+R*R*A(10)+Q*R*A(11)+P*R*A(12)+  
     +      P*Q*A(13)   
            IF(T.LT.A(JZ)) THEN
C               WRITE(23,*)' Orientation rejected by SHORT DISTANCE TEST'
C               WRITE(23,*)'NREFND,NT,SQRT(T),SQRT(A(JZ)) ',
C     +                     NREFND,NT,SQRT(T),SQRT(A(JZ))
               GOTO 68
            ENDIF   
            S=AMIN1(S,T)
            K=K+4   
            GOTO 74 
  75        NX=LY+12
  76      CONTINUE  
  77    CONTINUE
      IF(JZ.EQ.41)GOTO 78   
      G(10)=1.  
      GOTO 112  
C   
C REFINE TRANSLATION(S) 
C   
  78  QX=1. 
      IF(MK.EQ.65)QX=0. 
      R=A(44)  
      Z=0.  
        DO 79 I=2,MI
  79    B(I)=G(I)   
      NX=1  
  80  NX=NX+1
      IF(NX.LE.MI)GOTO 81   
      IF(Z.LT.R)THEN
         NRTPRS=NRTPRS+1
         GOTO 69 
      ENDIF
      QX=QX/A(43)   
      R=R+E(13) 
      NX=2  
  81  IF(A(NX+43).LT.1.E-6)GOTO 80  
      Z=-9.E9   
      S=Z   
  82  I=NE-4
      J=MX-9
  83  I=I+4 
      U=0.  
      V=0.  
        DO 85 K=65,LY,12
        J=J+9   
        Q=AMOD(A(J)*G(2)+A(J+1)*G(3)+A(J+2)*G(4),1.)*1000.  
        IF(Q.LT.0.)Q=Q+1000.
        N=INT(Q)
        L=INT(1.5+1000.*(Q-FLOAT(N)))   
        Q=F(N+1)*C(L)+F(N+251)*D(L) 
        P=F(N+251)*C(L)-F(N+1)*D(L) 
        IF(MI.EQ.4)GOTO 84  
        Y=AMOD(A(J)*G(5)+A(J+1)*G(6)+A(J+2)*G(7),1.)*1000.  
        IF(Y.LT.0.)Y=Y+1000.
        N=INT(Y)
        L=INT(1.5+1000.*(Y-FLOAT(N)))   
        Y=F(N+1)*C(L)+F(N+251)*D(L) 
        X=F(N+251)*C(L)-F(N+1)*D(L) 
        U=U+X*A(J+7)-Y*A(J+8)   
        V=V+X*A(J+8)+Y*A(J+7)   
  84    U=U+A(J+3)+P*A(J+5)-Q*A(J+6)
  85    V=V+A(J+4)+P*A(J+6)+Q*A(J+5)
      V=A(23)*V 
      T=SQRT(U*U+V*V)   
      IF(T.LT.0.0001)T=1.   
      A(I+2)=A(I+1)*U/T 
      A(I+3)=A(I+1)*V/T 
      IF(I.LT.MF)GOTO 83
      W=0.  
      L=MT  
  86  L=L+5 
      IF(A(L).LT.0.)GOTO 87 
      I=INT(A(L))   
      J=INT(ABS(A(L+1)))
      K=INT(ABS(A(L+2)))
      U=A(J+1)*SIGN(1.,A(L+1))  
      V=A(K+1)*SIGN(1.,A(L+2))  
      X=A(J)*A(K)-U*V   
      Y=A(J)*V+A(K)*U   
      U=X*A(L+3)+Y*A(L+4)   
      V=Y*A(L+3)-X*A(L+4)   
      W=W+U*A(I)+V*A(I+1)   
  87  IF(L.LT.MR)GOTO 86
      W=W/A(26) 
      IF(ABS(QX).LT.0.1)GOTO 90 
      IF(Z.GT.W)GOTO 88 
      S=Z   
      Z=W   
      G(NX)=G(NX)+QX*A(NX+43)   
      GOTO 82   
  88  IF(S.GT.-1.E9)GOTO 89 
      S=W   
      QX=-QX
      G(NX)=G(NX)+2.*QX*A(NX+43)
      GOTO 82   
  89  G(NX)=G(NX)+QX*A(NX+43)*(0.5*(W-S)/(2.001*Z-W-S)-1.)  
      GOTO 80   
C   
C FINAL DISTANCE TEST   
C   
  90  G(9)=W
      B(1)=B(1)+1.  
        DO 91 I=2,MI
        S=ABS(G(I)-B(I))
        B(I+6)=B(I+6)+S 
  91    B(I+12)=AMAX1(B(I+12),S)
      S=9.E9
      JZ=42 
      IF(IN(51).EQ.1)GOTO 72
      NP=MQ+12  
      A(NP)=-9.E9   
  92  NC=INT(A(30)+0.1) 
        DO 110 I=LK,LX,8
        X=A(I+2)
        Y=A(I+3)
        Z=A(I+4)
        N=INT(3.1*A(I+7))   
        IF(N.EQ.0)GOTO 93   
        X=X+G(N-1)  
        Y=Y+G(N)
        Z=Z+G(N+1)  
  93      DO 109 L=I,LX,8   
          M=INT(3.1*A(L+7)) 
          IF((M+N)*20-JZ.LT.0)GOTO 109  
          U=A(L+2)  
          V=A(L+3)  
          W=A(L+4)  
          NX=LY+16  
          IF(N.NE.M)NX=NX-4 
          IF(JZ.EQ.0)NX=LY+12   
          IF(M.EQ.0)GOTO 94 
          U=U+G(M-1)
          V=V+G(M)  
          W=W+G(M+1)
  94        DO 108 J=65,LY,12   
            XS=A(J)*U+A(J+1)*V+A(J+2)*W+A(J+9)  
            YS=A(J+3)*U+A(J+4)*V+A(J+5)*W+A(J+10)   
            ZS=A(J+6)*U+A(J+7)*V+A(J+8)*W+A(J+11)   
            K=NX
  95        IF(K.GT.LL)GOTO 108 
            P=AMOD(A(K+1)+XS*A(K)-X,1.)-0.5 
            Q=AMOD(A(K+2)+YS*A(K)-Y,1.)-0.5 
            R=AMOD(A(K+3)+ZS*A(K)-Z,1.)-0.5 
            IF(JZ.EQ.0)GOTO 98  
            T=P*P*A(8)+Q*Q*A(9)+R*R*A(10)+Q*R*A(11)+P*R*A(12)+  
     +      P*Q*A(13)   
            IF(A(I+1).GT.0.)GOTO 96 
            IF(A(L+1).LT.0.)GOTO 97 
  96        IF(T.LT.A(JZ))GOTO 68   
  97        S=AMIN1(S,T)
            IF(AMIN1(A(I+6),A(L+6)).LT.4.9)GOTO 107 
            IF(MK.EQ.65)GOTO 107
C   
C CALCULATE TFOM
C   
  98          DO 100 NJ=LJ,LS,9 
              TX=P*A(NJ)+Q*A(NJ+1)+R*A(NJ+2)
              TY=P*A(NJ+3)+Q*A(NJ+4)+R*A(NJ+5)  
              TZ=P*A(NJ+6)+Q*A(NJ+7)+R*A(NJ+8)  
                DO 100 NK=LN,LH,3   
                PL=A(NK)+TX 
                PA=A(NK+1)+TY   
                PD=A(NK+2)+TZ   
                NL=INT(0.5+A(36)*AMOD(PL-A(33),1.)) 
                IF(NL.GE.NC)GOTO 99 
                NA=INT(0.5+A(37)*AMOD(PA-A(34),1.)) 
                IF(NA.GT.50)GOTO 99 
                ND=INT(0.5+A(38)*AMOD(PD-A(35),1.)) 
                IF(ND.LT.51)GOTO 102
  99            NL=INT(0.5+A(36)*AMOD(199.-PL-A(33),1.))
                IF(NL.GE.NC)GOTO 100
                NA=INT(0.5+A(37)*AMOD(199.-PA-A(34),1.))
                IF(NA.GT.50)GOTO 100
                ND=INT(0.5+A(38)*AMOD(199.-PD-A(35),1.))
                IF(ND.LT.51)GOTO 102
 100            CONTINUE
            WRITE(LI,101)P,Q,R  
            STOP
 101        FORMAT(/' ** BAD VECTOR:',3F8.4///) 
 102        NA=NA+ND*51 
            NL=MB+MC*NL+NA/MD   
            NA=INT(A(NL))/8**(MD-MOD(NA,MD)-1)  
            PD=(FLOAT(MOD(NA,8))+0.3)/(A(I+6)*A(L+6))   
            IF(JZ.NE.0)GOTO 103 
            IF(AMIN1(A(I+6),A(L+6)).LT.0.5)GOTO 107 
            A(I+5)=A(I+5)+PD
            IF(I.NE.L)A(L+5)=A(L+5)+PD  
            GOTO 107
 103        NA=NP+1 
            NL=NA   
 104        NL=NL-1 
            IF(A(NL).GT.PD)GOTO 104 
            GOTO 106
 105        A(NA+1)=A(NA)   
 106        NA=NA-1 
            IF(NA.GT.NL)GOTO 105
            A(NL+1)=PD  
            NP=MIN0(MP,NP+1)
 107        K=K+4   
            GOTO 95 
 108        NX=LY+12
 109      CONTINUE  
 110    CONTINUE
      IF(JZ.EQ.0)GOTO 147   
      G(10)=0.  
      IF(MK.EQ.65)GOTO 112  
      I=MQ+12   
 111  I=I+1 
      G(10)=G(10)+A(I)  
      IF(I.LT.NP)GOTO 111   
      G(10)=G(10)*A(57) 
 112  IF(IABS(MZ-4).EQ.2)G(15)=G(10)
      G(1)=0.5*(G(10)+G(15))
      IF(A(55).GT.0.)G(1)=G(1)*SQRT(G(9))   
      IF(MS.LT.MQ)GOTO 113  
      IF(G(1).LT.A(MS))GOTO 69  
 113  IF(S.GT.1.E9)S=1.E-6  
      G(8)=SQRT(S)
  
C   
C SORT NON-EQUIVALENT SOLUTIONS 
C   
      R=A(1)/8. 
      S=0.5*E(6)
      T=S+10.   
      J=MS+12   
 114  J=J-12
      IF(J.LT.MR+17)GOTO 117
      IF(AMAX1(0.1*ABS(A(J+7)-G(8)),ABS(A(J+8)-G(9)),   
     +ABS(A(J+9)-G(10))).LT.0.001)GOTO 116  
      L=J+1 
        DO 115 K=2,MI   
        IF(ABS(AMOD(A(L)-G(K)+T,E(6))-S)*A(K).GT.R)GOTO 114 
 115    L=L+1   
 116  JE=JE+1   
      IF(A(J).GT.G(1))GOTO 69   
      MS=MS-12  
      GOTO 118  
 117  J=MS+12   
 118  K=J   
 119  J=J-12
      IF(A(J)-G(1))119,121,121  
 120  A(K+12)=A(K)  
 121  K=K-1 
      IF(K.GT.J+11)GOTO 120 
        DO 122 K=1,12   
        A(J+12)=G(K)
 122    J=J+1   
      MS=MIN0(MS+12,MQ)
      GOTO 69   
C   
C CALCULATE RE AND FINAL CFOM   
C   
 123  FORMAT(//4X,'** NO TRAN SOLUTION'/)   
 124  NN=NN+5   
      IF(MS.GT.MR+5)GOTO 125
      WRITE(LI,123) 
      GOTO 152  
 125  WRITE(LI,66)
CMB
      WRITE(*,702)NREFND,NINT(A(39)),NQ+NRTPRS+NF
      WRITE(*,703)NQ
      WRITE(*,704)NRTPRS
      WRITE(*,705)NF
703   FORMAT(' ',I10,' REJECTED BY PRELIMINARY DISTANCE TEST ')
704   FORMAT(' ',I10,' REJECTED BECAUSE OF TOO LOW TPRSUM ')
705   FORMAT(' ',I10,' REJECTED BY FINAL DISTANCE TEST ')

      NREFND=0
      NRTPRS=0
      T=A(27)*A(27) 
      IF(A(23).LT.0.5)T=T/2.
      M=MR+5
 126  M=M+12
        DO 127 I=11,13  
 127    G(I)=0. 
      I=NE-4
      J=MX-9
 128  I=I+4 
      U=0.  
      V=0.  
        DO 130 K=65,LY,12   
        J=J+9   
        Q=AMOD(A(J)*A(M+1)+A(J+1)*A(M+2)+A(J+2)*A(M+3),1.)*1000.
        IF(Q.LT.0.)Q=Q+1000.
        N=INT(Q)
        L=INT(1.5+1000.*(Q-FLOAT(N)))   
        Q=F(N+1)*C(L)+F(N+251)*D(L) 
        P=F(N+251)*C(L)-F(N+1)*D(L) 
        IF(MI.EQ.4)GOTO 129 
        Y=AMOD(A(J)*A(M+4)+A(J+1)*A(M+5)+A(J+2)*A(M+6),1.)*1000.
        IF(Y.LT.0.)Y=Y+1000.
        N=INT(Y)
        L=INT(1.5+1000.*(Y-FLOAT(N)))   
        Y=F(N+1)*C(L)+F(N+251)*D(L) 
        X=F(N+251)*C(L)-F(N+1)*D(L) 
        U=U+X*A(J+7)-Y*A(J+8)   
        IF(A(23).GT.0.5)V=V+X*A(J+8)+Y*A(J+7)   
 129    U=U+A(J+3)+P*A(J+5)-Q*A(J+6)
        IF(A(23).GT.0.5)V=V+A(J+4)+P*A(J+6)+Q*A(J+5)
 130    CONTINUE
      S=(U*U+V*V)/T 
      G(11)=G(11)+A(I+1)*SQRT(S)
      G(12)=G(12)+S 
      S=A(I+1)-SQRT(S/A(64))
      IF(S.LT.0.)S=0.2*ABS(S)   
      G(13)=G(13)+S 
      IF(I.LT.ME)GOTO 128   
      A(M+10)=G(13)/E(14)   
      A(M+11)=SQRT(1.-G(11)*G(11)/(E(15)*G(12)))
      A(M)=A(M)*0.2/A(M+10) 
      IF(MG.EQ.0)A(M)=A(M)/A(M+11)  
      IF(M.LT.MS)GOTO 126   
      I=MR+17   
 131  K=I-12
      S=-10.
 132  K=K+12
      IF(K.GT.MS)GOTO 133   
      IF(A(K).LT.S)GOTO 132 
      S=A(K)
      J=K   
      GOTO 132  
 133    DO 134 K=1,12   
        S=A(I)  
        A(I)=A(J)   
        A(J)=S  
        I=I+1   
 134    J=J+1   
      IF(I.LT.MS)GOTO 131   
C   
C PRINT BEST SOLUTIONS  
C   
      J=MR+17   
      K=MS+11   
      WRITE(LI,67)(A(I),I=J,K)  
CMB
C speichern des besten CFOM-Wertes in CFOMMX
C wenn eine Bessere Loesung gefunden wurde, wird das .REP-File
C zurueck- und bis FMAP wieder vorgespult, um diese Koordinaten
C auf das REP-File zu schreiben.
C CFOMMX wird beim Programmstart auf -1.0 gesetzt. So wird beim
C Schreiben des ersten Koordinatensatzes das REP-File nicht
C zurueckgespult.
      WRITLP=.FALSE.
      IF (A(J).GT.CFOMMX) THEN 
         IF (CFOMMX.GT.0) THEN
            REWIND(LP)
1006        READ(LP,'(A)')ZEILE
            IF(ZEILE(1:4).NE.'FMAP') GOTO 1006
         ENDIF
         CFOMMX=A(J)
         WRITLP=.TRUE.
      ENDIF
 135  FORMAT(/I6,' TRIES REJECTED ON PRELIMINARY AND',I6,' ON ',
     +'FINAL DISTANCE CHECK'/I6,' EQUIVALENT SOLUTIONS IGNORED')
 136  FORMAT(/'  FRACTIONAL COORDINATES FOR TRAN SOLUTION',I3,  
     +' (RMIN =',F6.2,' / TPRSUM =',F6.3,' /'/8X,'TFOM =',F6.3, 
     +' / RE(1) =',F6.3,' / RE(2) =',F6.3,' / CFOM =',F7.3,'):')
 137  FORMAT(/17X,'ATOM',3X,'TYPE',5X,'X',8X,'Y',8X,'Z',
     +8X,'PSUM'/)   
 138  FORMAT(17X,4A1,I6,3F9.4,F10.2)
 139  FORMAT(/46X,'MEAN PSUM =',F7.2)   
 140  FORMAT(//'  MEAN AND MAXIMUM COORDINATE SHIFTS DURING',   
     +' REFINEMENT (IN ANGSTROMS):'//'  MEAN',2(1X,3F6.2)/  
     +'  MAX.',2(1X,3F6.2)/)
      IF(MK.EQ.65)GOTO 142  
        DO 141 I=2,MI   
        B(I+6)=B(I+6)*A(I)/AMAX1(B(1),1.)   
 141    B(I+12)=B(I+12)*A(I)
      WRITE(LI,135)NQ,NF,JE 
      WRITE(LI,140)(B(I),I=8,19)
 142  IJ=MR+5   
 143  IJ=IJ+12  
      IF(IJ.GT.MS)GOTO 152  
      IF(A(40).LT.0.)GOTO 144   
      IF(IJ.GT.MR+17)GOTO 152   
 144  I=(IJ-MR)/12  
      WRITE(LI,136)I,(A(IJ+J),J=7,11),A(IJ) 
        DO 145 I=LK,LX,8
 145    A(I+5)=-7.3/A(I+6)**2   
      J=IJ  
        DO 146 I=2,7
        J=J+1   
 146    G(I)=A(J)   
      JZ=0  
      GOTO 92   
 147  WRITE(LI,137) 
      IF(E(11).GT.0.5)GOTO 150  
      N=0   
        DO 148 I=LK,LX,8
        IF(A(I+6).LT.13.5)GOTO 149  
 148    N=N+1   
 149  WRITE(LP,154)N
 150  A(IJ-2)=0.
      A(IJ-1)=0.
      A(IJ)=0.  
      S=0.  
        DO 151 I=LK,LX,8
        J=INT(A(I+1)+SIGN(0.1,A(I+1)))  
        N=IJ+INT(3.1*A(I+7))
        G(1)=A(I+2)+A(N-2)  
        G(2)=A(I+3)+A(N-1)  
        G(3)=A(I+4)+A(N)
        G(4)=A(I+5)*A(20)   
        IF(A(I+6).LT.0.5)G(4)=0.
        S=S+G(4)
        CALL UNPACK(A(I),IC)
        IF(A(I+6).LT.0.5)GOTO 151   
CMB Die folgenden zwei auskommentierten Zeilen wurden geaendert in
c        IF(E(11).LT.0.5)WRITE(LP,155)IC,J,(G(K),K=1,3)  
c 151    WRITE(LI,138)IC,J,(G(K),K=1,4)  
CMB Anfang
        IF(WRITLP     ) WRITE(LP,155)IC,J,(G(K),K=1,3)  
        IF(NLSTAT.GT.0) THEN
           ATEMP=IC(1)//IC(2)//IC(3)//IC(4)
           DO 1001 I1=1,NLSTAT
              IF (ALSTAT(I1)(1:LLSTAT(I1)).EQ.
     &                 ATEMP(1:LLSTAT(I1))) THEN
                 WRITE(LI,138)IC,J,(G(K),K=1,4)  
                 GOTO 151
              ENDIF
1001          CONTINUE
        ELSE 
           IF (.NOT.NOAT) THEN
              WRITE(LI,138)IC,J,(G(K),K=1,4)  
           ENDIF
        ENDIF
 151    CONTINUE
CMB Ende
      IF(E(11).LT.0.5)E(11)=1.  
      IF(LX.EQ.LK)GOTO 143  
      S=S/FLOAT((LX-LK+8)/8)
      WRITE(LI,139)S
      GOTO 143  
 152  IF(MZ.EQ.7)A(NN-5)=-1.
      IF(MZ.NE.3)GOTO 153   
      IF(NN.LE.LO)GOTO 36   
 153  IF(A(25).LT.0.5)WRITE(LI,157)MP   
      WRITE(LP,156) 
 154  FORMAT('TEXP 200',I3/'FMAP 9')
 155  FORMAT(4A1,I4,3F9.4)  
 156  FORMAT('HKLF 4')  
 157  FORMAT(////' HIGHEST MEMORY USED FOR TRANSLATION SEARCH =',   
     +I7//) 
      RETURN
      END   
C                
C --------------------------------------------------------------
C   
      SUBROUTINE RESET 
C --------------------------------------------------------------
C   
C   
C RESETS ALL VARIABLES IMPLEMENTED BY MB
C   
C ** NEXT STATEMENT MUST HAVE C IN COLUMN 1 IF NOT FORTRAN-77 **
      CHARACTER*1 IH,IT,IC  
C   
      DIMENSION IC(4),B(19),C(1001),D(1001),F(1251) 
C   
      include 'PATSEE.INC'

      NLSTAT= 0
      NOAT  =.FALSE.
      FRGFIL=.FALSE.
      CFOMMX= -1.0
C
      RETURN
      END
      
      
